/* Listato 106 */

#define	Points		14	/* linee di scansione visualizzate per carattere */
#define	StartCharCode	0x80	/* primo codice di caratt. nella "finestra" */
#define	CGenDefSize	32	/* (usa 16 per Hercules) */

char far *CRT_MODE = 0x00400049;	/* numero modalit video del BIOS */
int  far *CRT_COLS = 0x0040004A;	/* caratteri per riga */

char far *VideoBuffer;			/* puntatore al buffer del video */
char far *CharDefTable = 0xA0000000;	/* puntatore alla RAM di definizione caratt. */
					/* (usa 0xB0004000 per Hercules) */
main()
{
	int	i;
	int	CharCode;
	int	CharOffset;
	int	CharScanLine;
	int	CharDefOffset;
	int	Row,Column;


	/* stabilisce modalit alfanumerica */

	if (*CRT_MODE == 7)		/* imposta puntatore buffer del video */
	  VideoBuffer = 0xB0000000;
	else
	  VideoBuffer = 0xB8000000;

	AlphaModeSet( 8, Points, 8 );


	/* stabilisce una finestra grafica a mosaico nell'angolo superiore sinistro */

	CharCode = StartCharCode;

	for ( Row=0; Row<4; Row++ )
	  for ( Column=0; Column< 32; Column++ )
	  {
	    CharOffset = (Row*(*CRT_COLS) + Column) * 2;
	    VideoBuffer[CharOffset] = CharCode++;
	  }		


	/* cancella la finestra */

	CGenModeSet();		/* rende indirizzabile la RAM del generatore di caratteri */

	for (CharCode=StartCharCode; CharCode<256; CharCode++ )
	  for ( CharScanLine=0; CharScanLine<Points; CharScanLine++ ) 
	  {
	    CharDefOffset = CharCode*CGenDefSize + CharScanLine;
	    CharDefTable[CharDefOffset] = 0;
	  }


	/* traccia alcune linee */

	for ( i=0; i<256; i++ )		/* linee orizzontali */
	{
	  SetPixel( i, 0 );
	  SetPixel( i, 4*Points-1 );
	}

	for ( i=0; i<4*Points-1; i++ )	/* linee verticali */
	{
	  SetPixel( 0, i );
	  SetPixel( 255, i );
	}

	for( i=0; i<Points*4; i++ )	/* linee diagonali */
	{
	  SetPixel( i, i );
	  SetPixel( 255-i, i );
	}

	CGenModeClear();		/* ripristina modalit alfanumerica */

}

SetPixel( x, y )
int	x,y;		/* coordinate di pixel */
{
	int	CharCode;
	int	CharScanLine;
	int	BitMask;
	int	CharDefOffset;


	CharCode = StartCharCode + (y/Points)*32 + x/8;
	CharScanLine = y % Points;		/* Punti y MOD */
	BitMask = 0x80 >> (x % 8);		/* 10000000b SHR (x MOD 8) */

	CharDefOffset = CharCode*CGenDefSize + CharScanLine;
	CharDefTable[CharDefOffset] |= BitMask;	/* effettua l'OR del pixel */
}
