		TITLE	'Listato 89'
		NAME	CGenModeSet
		PAGE	55,132

;
; Nome:		CGenModeSet
;
;		Accesso diretto alla RAM del generatore di caratteri alfanumerici EGA e VGA
;
; Chiamante:	Microsoft C:
;
;			azzera CGenModeSet();
;

DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		PUBLIC	_CGenModeSet
_CGenModeSet	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		push	si

; programma il sequencer

		cli			; disabilita interrupt
		mov	dx,3C4h		; indirizzo di porta del sequencer
		mov	si,offset DGROUP:SeqParms
		mov	cx,4

L01:		lodsw			; AH := valore del registro del sequencer
					; AL := numero registro
		out	dx,ax		; programma il registro
		loop	L01
		sti			; abilita interrupt

; programma il controller grafico

		mov	dl,0CEh		; DX := 3CEH (indirizzo di porta del
					;	controller grafico)
		mov	si,offset DGROUP:GCParms
		mov	cx,3

L02:		lodsw			; programma il controller grafico
		out	dx,ax
		loop	L02

		pop	si
		pop	bp
		ret		

_CGenModeSet	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

; il formato dei parametri : byte meno significativo : numero registro
;                             byte pi significativo:   valore del reg

SeqParms	DW	0100h		; ripristino sincrono
		DW	0402h		; CPU scrive solo su mappa 2
		DW	0704h		; indirizzamento sequenziale
		DW	0300h		; azzera ripristino sincrono

GCParms		DW	0204h		; seleziona mappa 2 per letture di CPU
		DW	0005h		; disabilita indirizzamento dispari-pari
		DW	0006h		; mappa inizia a A000:0000

_DATA		ENDS

		END
