		TITLE	'Listato 90'
		NAME	CGenModeClear
		PAGE	55,132

;
; Nome:		CGenModeClear
;
;		Ripristina modalit alfanumerica EGA o VGA dopo l'accesso
;		alla RAM del generatore di caratteri
;
; Chiamante:	Microsoft C:
;
;			azzera CGenModeClear();
;


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		PUBLIC	_CGenModeClear
_CGenModeClear	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp
		push	si

; programma il sequencer

		cli			; disabilita interrupt
		mov	dx,3C4h		; indirizzo di porta del sequencer
		mov	si,offset DGROUP:SeqParms
		mov	cx,4

L01:		lodsw			; AH := valore del registro del sequencer
					; AL := numero registro
		out	dx,ax		; programma il registero
		loop	L01
		sti			; abilita interrupt

; programma controller grafico

		mov	dl,0CEh		; DX := 3CEH (indirizzo di porta del
					;	             controller grafico)
		mov	si,offset DGROUP:GCParms
		mov	cx,3

L02:		lodsw			; programma controller grafico
		out	dx,ax
		loop	L02

		mov	ah,0Fh		; AH := numero funzione INT 10H
		int	10h		; attiva modalit video

		cmp	al,7
		jne	L03		; salta se non  modalit monocromatica

		mov	ax,0806h	; programma controller grafico
		out	dx,ax		;  per iniziare mappa a B000:0000

L03:		pop	si
		pop	bp
		ret		

_CGenModeClear	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

; il formato dei parametri :  byte meno significativo:  numero registro
;                              byte pi significativo:   valore del reg

SeqParms	DW	0100h		; ripristino sincrono
		DW	0302h		; CPU scrive su mappe 0 e 1
		DW	0304h		; indirizzamento dispari-pari
		DW	0300h		; azzera ripristino sincrono

GCParms		DW	0004h		; seleziona mappa 0 per letture di CPU
		DW	1005h		; abilita indirizzamento dispari-pari
		DW	0E06h		; mappa inizia a B800:0000

_DATA		ENDS

		END
