		TITLE	'Listato 108'
		NAME	GetBitBlock06
		PAGE	55,132

;
; Nome:		GetBitBlock06
;
; Funzione:	Copia un blocco di bit dal buffer del video alla RAM di sistema
;		 nella modalit a 2 colori 640x200
;
; Chiamante:	Microsoft C:
;
;			int GetBitBlock06(x0,y0,x1,y1,buf);
;
;			     int x0,y0;    /* angolo super. sinistro del blocco di bit */
;			     int x1,y1;       /* angolo inferiore destro */
;			     char far *buf;   /* buffer */
;
; Nota:		Ritorna dimensione del blocco di bit nella RAM di sistema.
;


ARGx0		EQU	word ptr [bp+4]
ARGy0		EQU	word ptr [bp+6]
ARGx1		EQU	word ptr [bp+8]
ARGy1		EQU	word ptr [bp+10]
ADDRbuf		EQU	         [bp+12]

VARPixelRows	EQU	word ptr [bp-2]
VARPixelRowLen	EQU	word ptr [bp-4]
VARincr		EQU	word ptr [bp-6]

ByteOffsetShift	EQU	3		; rispecchia numero di pixel per byte


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr06:near

		PUBLIC	_GetBitBlock06
_GetBitBlock06	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,6		; stabilisce cornice di stack
		push	ds
		push	si
		push	di

; calcola dimensioni del blocco di bit

		mov	ax,ARGx1
		sub	ax,ARGx0
		mov	cx,0FF07h	; CH := maschera di bit non spostata
					; CL := esegue AND della maschera per AL
		and	cl,al		; CL := numero di pixel nell'ultimo
					;  byte della riga
		xor	cl,7		; CL := numero di bit da spostare
		shl	ch,cl		; CH := maschera di bit per ultimo byte della riga
		mov	cl,ch
		push	cx		; salva su stack

		mov	cl,ByteOffsetShift
		shr	ax,cl
		inc	ax		; AX := numero di byte per riga
		push	ax		; salva su stack

		mov	ax,ARGy1
		sub	ax,ARGy0
		inc	ax		; AX := numero di righe di pixel
		push	ax		; salva su stack

; stabilisce indirizzamento

		mov	ax,ARGy0
		mov	bx,ARGx0
		call	PixelAddr06	; ES:BX -> x0,y0 nel buffer del video
		xor	cl,7		; CL := numero di bit da spostare a sinistra
		push	es
		pop	ds
		mov	si,bx		; DS:SI -> buffer del video

		mov	bx,2000h	; BX := incrementa da prima a seconda
					;  intercalazione nel buffer del video del CGA
		test	si,2000h
		jz	L01		; salta se x0,y0  nella prima intercalazione

		mov	bx,80-2000h	; incrementa da seconda a prima intercalazione

L01:		mov	VARincr,bx	; inizializza questa variabile

		les	di,ADDRbuf	; ES:DI -> buffer nella RAM di sistema

; crea intestazione a 5 byte del blocco di bit

		pop	ax
		mov	VARPixelRows,ax
		stosw			; byte 0-1 := numero di righe di pixel
		pop	ax
		mov	VARPixelRowLen,ax
		stosw			; byte 2-3 := byte per riga di pixel
		pop	ax
		mov	ch,al		; CH := maschera di bit per ultimo byte
		stosb			; byte 4 := maschera di bit per ultimo byte

; copia dal buffer del video alla RAM di sistema

L02:		mov	bx,VARPixelRowLen
		push	si		; mantiene SI all'inizio della riga di pixel

L03:		lodsw			; AL := byte successivo nel buffer del video
					; AH := (byte successivo) + 1
		dec	si		; DS:SI -> (byte successivo) + 1
		rol	ax,cl		; AL := successivi 4 pixel nella riga
		stosb			; copia sulla RAM ddi sistema
		dec	bx		; loop sulla riga
		jnz	L03

		and	es:[di-1],ch	; maschera ultimo byte di riga
		pop	si		; DS:SI -> inizio di riga
		add	si,VARincr	; DS:SI -> inizio di riga successiva
		xor	VARincr,2000h XOR (80-2000H)  ; aggiorna incremento

		dec	VARPixelRows
		jnz	L02		; loop verso il basso sulle righe

		mov	ax,di
		sub	ax,ADDRbuf	; AX := ritorna valore (dimens. blocco di bit
					;  nella RAM di sistema)

		pop	di		; ripristina registri ed esce
		pop	si
		pop	ds
		mov	sp,bp
		pop	bp
		ret

_GetBitBlock06	ENDP

_TEXT		ENDS

		END
