		TITLE	'Listato  109'
		NAME	StoreBitBlock06
		PAGE	55,132

;
; Nome:		StoreBitBlock06
;
; Funzione:	Copia un blocco di bit dal buffer del video alla RAM di sistema
;		 nella modalit a 2 colori  640x200
;
; Chiamante:	Microsoft C:
;
;			azzera StoreBitBlock06(buf,x,y);
;
;			     char far *buf;   /* buffer */
;			     int x,y;    /* angolo superiore sinistro del blocco di bit */
;


ADDRbuf		EQU	dword ptr [bp+4]
ARGx		EQU	word ptr [bp+8]
ARGy		EQU	word ptr [bp+10]

VARPixelRows	EQU	word ptr [bp-2]
VARPixelRowLen	EQU	word ptr [bp-4]
VARincr		EQU	word ptr [bp-6]


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr06:near

		PUBLIC	_StoreBitBlock06
_StoreBitBlock06 PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,6		; stabilisce cornice di stack
		push	ds
		push	si
		push	di

; stabilisce indirizzamento

		mov	ax,ARGy
		mov	bx,ARGx
		call	PixelAddr06	; ES:BX -> offset di byte di x,y
		xor	cl,7		; CL := numero di bit da spostare a destra

		mov	di,bx		; ES:DI -> x,y nel buffer del video
		
		mov	bx,2000h	; BX := incrementa dalla prima alla seconda
					;  intercalazione nel buffer del video del CGA
		test	di,2000h
		jz	L01		; salta se x,y  nella prima intercalazione

		mov	bx,80-2000h	; incrementa da seconda a prima intercalazione

L01:		mov	VARincr,bx	; inizializza questa variabile

		mov	bx,StoreBitBlockOp  ; BX := indirizzo della subroutine

		lds	si,ADDRbuf	; ES:DI -> buffer nella RAM del sistema

; ricava dimensioni del blocco di bit dall'intestazione

		lodsw			; AX := numero di righe di pixel
		mov	VARPixelRows,ax
		lodsw			; AX := byte per riga di pixel
		mov	VARPixelRowLen,ax
		lodsb			; AL := maschera di bit per ultimo byte nella riga
		mov	ch,al

		jmp	bx		; salta a subroutine


ReplaceBitBlock:
		cmp	cx,0FF00h	; se maschera <> 0FFH o bit da spostare <> 0
		jne	L15		;  salta se non allineato al byte

; routine per blocchi di bit allineati al byte

		mov	cx,VARPixelRowLen

L10:		push	di		; mantiene DI e CX
		push	cx
		rep	movsb		; copia una riga di pixel nel buffer del video
		pop	cx		; ripristina DI e CX
		pop	di	
		add	di,VARincr	; ES:DI -> successiva riga di pixel nel buffer
		xor	VARincr,2000h XOR (80-2000h) ; aggiorna incremento
		dec	VARPixelRows
		jnz	L10		; loop verso il basso su righe di pixel

		jmp	Lexit

; routine per tutti gli altri blocchi di bit

L15:		not	ch		; CH := maschera per fine riga
		mov	dx,0FF00h
		ror	dx,cl		; DX := maschera ruotataper ogni byte

		mov	bx,VARPixelRowLen
		dec	bx		; BX := byte per riga - 1

L16:		push	di
		test	bx,bx
		jz	L18		; salta se solo un byte per riga

		push	bx

L17:		and	es:[di],dx	; maschera successivi 8 pixel nel buffer del video
		lodsb			; AL := pixel nel blocco di bit
		xor	ah,ah
		ror	ax,cl		; AX := pixel ruotati in posizione
		or	es:[di],ax	; imposta pixel nel buffer del video
		inc	di		; ES:DI -> byte successivo nel blocco di bit
		dec	bx
		jnz	L17

		pop	bx

L18:		mov	al,ch
		mov	ah,0FFh		; AX := maschera per ultimi pixel nella riga
		ror	ax,cl		; AX := maschera ruotata in posizione
		and	es:[di],ax	; maschera ultimi pixel nel buffer del video
		lodsb			; AL := ultimo byte nella riga
		xor	ah,ah
		ror	ax,cl		; AX := pixel ruotati in posizione
		or	es:[di],ax	; imposta pixel nel buffer del video

		pop	di
		add	di,VARincr	; ES:DI -> successiva riga di pixel nel buffer
		xor	VARincr,2000h XOR (80-2000h)
		dec	VARPixelRows
		jnz	L16		; loop verso il basso su righe di pixel

		jmp	Lexit


XORBitBlock:
		mov	bx,VARPixelRowLen

L20:		push	di
		push	bx

L21:		lodsb			; AL := pixel nel blocco di bit
		xor	ah,ah
		ror	ax,cl		; AX := pixel ruotati in posizione
		xor	es:[di],ax	; esegue XOR dei pixel nel buffer del video
		inc	di		; ES:DI -> byte successivo nel blocco di bit
		dec	bx
		jnz	L21

		pop	bx
		pop	di
		add	di,VARincr	; ES:DI -> successiva riga di pixel nel buffer
		xor	VARincr,2000h XOR (80-2000h)
		dec	VARPixelRows
		jnz	L20		; loop verso il basso su righe di pixel

		jmp	Lexit

ANDBitBlock:
		not	ch		; CH := maschera per fine riga

		mov	bx,VARPixelRowLen
		dec	bx		; BX := byte per riga - 1

L30:		push	di
		test	bx,bx
		jz	L32		; salta se solo un byte per riga

		push	bx

L31:		lodsb			; AL := pixel nel blocco di bit
		mov	ah,0FFh
		ror	ax,cl		; AX := pixel ruotati in posizione
		and	es:[di],ax	; esegue AND dei pixel nel buffer del video
		inc	di		; ES:DI -> byte successivo nel blocco di bit
		dec	bx
		jnz	L31

		pop	bx

L32:		lodsb			; AL := ultimo byte nella riga
		or	al,ch		; maschera ultimi pixel nella riga
		mov	ah,0FFh
		ror	ax,cl		; AX := pixel ruotati in posizione
		and	es:[di],ax	; esegue AND dei pixel nel buffer del video

		pop	di
		add	di,VARincr	; ES:DI -> successiva riga di pixel nel buffer
		xor	VARincr,2000h XOR (80-2000h)
		dec	VARPixelRows
		jnz	L30		; loop verso il basso su righe di pixel

		jmp	Lexit


ORBitBlock:
		mov	bx,VARPixelRowLen

L40:		push	di
		push	bx

L41:		lodsb			; AL := pixel nel blocco di bit
		xor	ah,ah
		ror	ax,cl		; AX := pixel ruotati in posizione
		or	es:[di],ax	; esegue OR dei pixel nel buffer del video
		inc	di		; ES:DI -> byte successivo nel blocco di bit
		dec	bx
		jnz	L41

		pop	bx
		pop	di
		add	di,VARincr	; ES:DI -> successiva riga di pixel nel buffer
		xor	VARincr,2000h XOR (80-2000h)
		dec	VARPixelRows
		jnz	L40		; loop verso il basso su righe di pixel


Lexit:		pop	di		; ripristina registri ed esce
		pop	si
		pop	ds
		mov	sp,bp
		pop	bp
		ret

_StoreBitBlock06 ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

StoreBitBlockOp	DW	ReplaceBitBlock	; indirizzo della subroutine selezionata
					;  (Sostituzione, XOR, AND, OR)

_DATA		ENDS

		END
