		TITLE	'Listato 128'
		NAME	GetHercMode
		PAGE	55,132

;
; Nome:		GetHercMode
;
; Funzione:	Determina modalit video su adattatori Hercules valutando la dimensione
;		dell'area visualizzata del buffer del video.
;
; Chiamante:	Microsoft C:
;
;			int GetHercMode(n);	/* ritorna dimensione approssimativa */
;						/*  dell'area visualizzata del */
;						/*  buffer del video in word   */
;

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	_GetHercMode
_GetHercMode	PROC	near

		push	bp		; mantiene BP
		mov	bp,sp

; azzera latch di penna ottica del CRTC

		mov	dx,3BBh		; DX := porta di azzeramento della penna ottica
		out	dx,al		; OUT a questa porta azzera il latch
					;  (il valore in AL non  significativo)

; attende inizio del prossimo ritracciamento verticale

		dec	dx		; DX := 3BAH (porta di stato del CRT)
L01:		in	al,dx		; attende inizio del ritracciam. verticale
		test	al,80h
		jnz	L01

L02:		in	al,dx		; attende fine del ritracciam. verticale
		test	al,80h
		jz	L02

		cli			; disabilita interrupt
L03:		in	al,dx		; attende inizio del ritracciam. verticale
		test	al,80h
		jnz	L03

; effettua latch del contatore corrente di indirizzo del CRTC nei registri di penna ottica

		dec	dx		; DX := 3B9H
		out	dx,al		; OUT a questa porta carica il latch
		sti			; riabilita interrupt

; ritorna il valore nei registri di penna ottica

		mov	dl,0B4h		; DX := 3B4H (porta di indirizzo del CRTC)
		mov	al,10h		; AL := numero registro penna ottica alta
		out	dx,al
		inc	dx
		in	al,dx		; legge questo registro
		dec	dx
		mov	ah,al		; AH := valore corrente di penna ottica alta

		mov	al,11h		; AL := numero registro penna ottica bassa
		out	dx,al
		inc	dx
		in	al,dx		; AX := valore corrente del latch di penna ottica
					;  (cio, valore del contatore di indirizzo del CRTC
					;  all'inizio del ritracciam. verticale)
		pop	bp
		ret		

_GetHercMode	ENDP

_TEXT		ENDS

		END
