		TITLE	'Listato 129'
		NAME	SetPixel
		PAGE	55,132

;
; Nome:		SetPixel
;
; Funzione:	Imposta il valore di un pixel nelle modalit grafiche EGA originali.
;
; Chiamante:	Microsoft C (modello a memoria ridotta)
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate del pixel */
;
;			int n;			/* valore del pixel */
;
; Note		Questa  la stessa routine del Capitolo 5.
;
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento della cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]

RMWbits		EQU	0		; legge-modifica-scrive bit


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr:near

		PUBLIC	_SetPixel
_SetPixel	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare verso sinistra

; imposta registro maschera di bit del controller grafico

		shl	ah,cl		; AH := maschera di bit nella posizione corretta
		mov	dx,3CEh		; porta registro di indirizzo GC
		mov	al,8		; AL := numero registro di maschera di bit
		out	dx,ax

; imposta registro modalit controller grafico

		mov	ax,0005h	; AL :=  numero registro modalit
					; AH :=  modalit di scrittura 0 (bit 0,1)
					;	 modalit di lettura 0 (bit 3)
		out	dx,ax

; imposta il registro rotazione dati/selezione funzione

		mov	ah,RMWbits	; AH := legge-modifica-scrive bit
		mov	al,3		; AL := reg rotazione dati/selez. funzione
		out	dx,ax

; imposta registri impostazione/azzeramento e abilitazione impostazione/azzeramento

		mov	ah,ARGn		; AH := valore di pixel
		mov	al,0		; AL := numero reg impostazione/azzeram.
		out	dx,ax

		mov	ax,0F01h	; AH := valore per abilit. impost./azzer. (tutti
					;  i piani di bit abilitati)
					; AL := numero reg abilit. impost./azzer.
		out	dx,ax

; imposta valore del pixel

		or	es:[bx],al	; carica i latch durante lettura di CPU
					; aggiorna latch e piani di bit durante
					;  scrittura di CPU


; ripristina registri di default del controller grafico

		mov	ax,0FF08h	; maschera di bit di default
		out	dx,ax

		mov	ax,0005		; registro di modalit di default
		out	dx,ax

		mov	ax,0003		; selezione funzione di default
		out	dx,ax
		mov	ax,0001		; abilitaz. impostaz/azzeram. di default
		out	dx,ax

		mov	sp,bp		; ripristina registri chiamante e ritorna
		pop	bp
		ret

_SetPixel	ENDP

_TEXT		ENDS

		END
