		TITLE	'Listato 137'
		NAME	SetPixel
		PAGE	55,132

;
; Nome:		SetPixel
;
; Funzione:	Imposta il valore di un pixel nelle modalit grafiche EGA originali.
;
; Chiamante:	Routine residente in memoria richiamata con interrupt 60H:
;
;			mov ax,PixelX	   ; coordinata x del pixel
;			mov bx,PixelY	   ; coordinata y del pixel
;			mov cx,PixelValue  ; valore del pixel
;
; Note:		- Assemblare e correlare per creare SETPIXEL.EXE.
;		- Eseguire una volta per rendere SetPixel residente in memoria e per puntare
;		   il vettore INT 60H al codice residente in RAM.
;		- Richiede MS-DOS versione 2.0 o successiva.
;

RMWbits		EQU	0

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr:near

		PUBLIC	SetPixel
SetPixel	PROC	near		; gestore di interrupt 60H residente in RAM

		sti			; abilita interrupt
		push	ax		; mantiene registri del chiamante su
		push	bx		;  stack del chiamante
		push	cx
		push	dx

		push	cx		; mantiene valore del pixel su stack

		call	PixelAddr	; calcola indirizzo del pixel
		shl	ah,cl

		mov	dx,3CEh		; programma il controller grafico
		mov	al,8		; AL := numero registro di maschera di bit
		out	dx,ax

		mov	ax,0005h
		out	dx,ax

		mov	ah,RMWbits	; AH := legge-modifica-scrive bit
		mov	al,3		; AL := reg rotazione dati/selez. funzione
		out	dx,ax

		pop	ax 
		mov	ah,al		; AH := valore di pixel
		mov	al,0
		out	dx,ax

		mov	ax,0F01h
		out	dx,ax

		or	es:[bx],al	; imposta valore di pixel

		mov	ax,0FF08h	; ripristina valori di default del
		out	dx,ax		;  controller grafico

		mov	ax,0005
		out	dx,ax

		mov	ax,0003
		out	dx,ax

		mov	ax,0001
		out	dx,ax

		pop	dx		; ripristina registri del chiamante e ritorna
		pop	cx
		pop	bx
		pop	ax
		iret

SetPixel	ENDP

_TEXT		ENDS


TRANSIENT_TEXT	SEGMENT	para
		ASSUME	cs:TRANSIENT_TEXT,ss:STACK

Install		PROC	near

		mov	ax,2560h	; AH := 25H (numero funzione INT 21H)
					; AL := 60H (numero interrupt)
		mov	dx,seg _TEXT
		mov	ds,dx
		mov	dx,offset _TEXT:SetPixel   ; DS:DX -> gestore interrupt

		int	21h		; punta vettore INT 60H su
					;  routine SetPixel

		mov	dx,cs		; DX := segmento di inizio della parte transiente
					;  (eliminabile) del programma
		mov	ax,es		; ES := prefisso del segmento del programma
		sub	dx,ax		; DX := dimensione della parte residente in RAM
		mov	ax,3100h	; AH := 31H (numero funzione INT 21H)
					; AL := 0 (codice di ritorno)
		int	21h		; conclude ma resta residente

Install		ENDP

TRANSIENT_TEXT	ENDS

STACK		SEGMENT	para stack 'STACK'

		DB	80h dup(?)	; spazio di stack per parte transiente
					;  del programma
STACK		ENDS

		END	Install
