		TITLE	'Listato 139'
		NAME	dgisrect
		PAGE	55,132

;
; Nome: 	dgisrect
;
; Funzione:	traccia un rettangolo pieno usando DGIS
;
; Note:		assemblare e correlare per creare DGISRECT.EXE
;

CR		EQU	0Dh
LF		EQU	0Ah

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:_DATA,ss:STACK

EntryPoint	PROC	far

		mov	ax,seg _DATA
		mov	ds,ax			; DS -> _DATA
		push	ss
		pop	es			; ES -> segmento di stack

; ricerca dispositivi DGIS installati

		xor	dx,dx			; DX = 0 (lunghezza buffer)
		xor	cx,cx			; CX = 0
		xor	bx,bx			; BX = 0
		mov	ax,6A00h		; AX = codice operativo DGIS (rileva
						;  dispostivi disponibili)
		int	10h
		or	cx,cx
		jnz	L01			; salta se dispositivo/i installato/i

		mov	dx,offset _DATA:Msg0
		jmp	ErrorExit

; trova dispositivo di output grafico nell'elenco dei dispositivi installati DGIS

L01:		inc	cx			; CX = (# di byte nell'elenco) + 1
		and	cx,0FFFEh		; CX = numero pari di byte
		mov	bp,sp
		sub	sp,cx			; stabilisce cornice di stack
						;  (SS:BP -> fine cornice)
		mov	di,sp			; ES:DI -> inizio della cornice di stack

		push	di			; salva per successivo uso
		mov	dx,cx			; DX = dimensione del buffer
		xor	cx,cx
		xor	bx,bx
		mov	ax,6A00h		; AX = codice operativo DGIS (rileva
						;  dispositivi disponibili)
		int	10h			; ottiene elenco dispositivi a ES:DI
		pop	di			; ES:DI -> elenco dispositivi

L02:		cmp	word ptr es:[di+2],0	;  un dispositivo grafico?
		je	L04			; salta in caso affermativo

		sub	bx,es:[di]		; BX = byte restanti nell'elenco
		jnz	L03			; salta se ci sono pi dispositivi nell'elenco

		mov	dx,offset _DATA:Msg1
		jmp	ErrorExit

L03:		add	di,es:[di]		; ES:DI -> dispositivo successivo nell'elenco
		jmp	L02

; stabilisce un collegamento logico con il dispositivo grafico
;  usando la prima configurazione disponibile sul dispositivo

L04:		les	di,es:[di+6]		; ES:DI -> punto di entrata dispositivo
		mov	word ptr GrDevEntry,di
		mov	word ptr GrDevEntry+2,es  ; salva punto di entrata

		mov	cx,0			; CX = indice prima configurazione
		mov	ax,0027h		; AX = codice operativo DGIS (collegamento)
		call	dword ptr GrDevEntry	; collega a dispositivo grafico
		cmp	bx,-1			; test dell'handle ritornato
		jne	L05			; salta se collegato

		mov	dx,offset _DATA:Msg2
		jmp	ErrorExit

L05:		mov	ChannelHandle,bx	; salva l'handle per uso succ.
		mov	ax,001Bh		; AX = codice oper. DGIS (inizializz. DGI)
		call	dword ptr GrDevEntry	; inizializza il dispositivo con
						;  attributi di default

; traccia un rettangolo pieno usando gli attributi di default

		mov	di,100			; DI = angolo inferiore destro y
		mov	si,100			; SI = angolo inferiore destro x
		mov	dx,0			; DX = angolo superiore sinistro y
		mov	cx,0			; CX = angolo superiore sinistro x
		mov	bx,ChannelHandle	; BX = handle
		mov	ax,003Fh		; AX = codice operativo DGIS (genera
						;      rettangolo pieno)
		call	dword ptr GrDevEntry

; scollega ed esce

		mov	bx,ChannelHandle	; BX = handle
		mov	ax,002Bh		; AX = codice operativo DGIS (scollegamento)
		call	dword ptr GrDevEntry

Lexit:		mov	ax,4C00h
		int	21h			; ritorna al DOS

ErrorExit:	mov	ah,9
		int	21h			; visualizza messaggio errore
		mov	ax,4C01h
		int	21h			; ritorna al DOS

EntryPoint	ENDP

_TEXT		ENDS


_DATA		SEGMENT	para public 'DATA'

GrDevEntry	DD	?			; punto di entrata dispositivo grafico
ChannelHandle	DW	?			; handle per la configurazione
						;  del dispositivo collegato

Msg0		DB	CR,LF,'Nessun dispositivo DGIS installato',CR,LF,'$'
Msg1		DB	CR,LF,'Nessun dispositivo grafico installato',CR,LF,'$'
Msg2		DB	CR,LF,'Impossibile collegamento a dispositivo grafico',CR,LF,'$'

_DATA		ENDS


STACK		SEGMENT	stack 'STACK'

		DB	400h dup(?)

STACK		ENDS

		END	EntryPoint
