		TITLE	'Listato 7'
		NAME	HRTimeout
		PAGE	55,132

;
; Nome:		HRTimeout
;
; Funzione:     Determina valore di superamento tempo per intervallo soppressione orizzontale
;
; Chiamante:	Microsoft C:
;
;			int HRTimeout();
;

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	_HRTimeout
_HRTimeout	PROC	near

		push	bp		; preambolo usuale C per stabilire
		mov	bp,sp		;  cornice di stack

		mov	ax,40h
		mov	es,ax		; ES := segmento dati del BIOS video

		mov	dx,es:[63h]	; DX := porta registro indirizzo del CRTC
		add	dl,6		; DX := porta per registro di stato del CRTC

; sincronizza con inizio del ciclo di ripristino

L01:		in	al,dx		; AL := stato del CRTC
		test	al,8		; test bit 3
		jz	L01		; loop mentre non avviene ritracciamento verticale

L02:		in	al,dx
		test	al,8
		jnz	L02		; loop durante ritracciamento verticale

; sincronizza con scansione orizzontale e temporizza l'intervallo di soppressione orizzontale

		mov	cx,0FFFFh	; CX := contatore di loop

		cli			; disabilita interrupt

L03:		in	al,dx
		test	al,1
		jnz	L03		; loop mentre abilitazione visualizzazione  disattivata

L04:		in	al,dx
		test	al,1
		jz	L04		; loop mentre abilitazione visualizzazione  attiva

L05:		in	al,dx
		test	al,1
		loopnz	L05		; decrementa CX ed esegue loop mentre
					;  abilitazione visualizzazione  disattiva

		sti			; riabilita interrupt

		mov	ax,cx		; AX := contatore di loop
		neg	ax
		shl	ax,1		; AX := valore di superamento tempo

		mov	sp,bp		; elimina cornice di stack e ritorna a C
		pop	bp
		ret

_HRTimeout	ENDP

_TEXT		ENDS

		END
