                TITLE   'Listato 9'
		NAME	HercGraphMode
		PAGE	55,132

;
; Nome:		HercGraphMode
;
; Funzione:	Impostare modalit grafica Hercules 720x348 su HGC, HGC+, InColor
;
; Chiamante:	Microsoft C:
;
;				annulla HercGraphMode();
;

DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		PUBLIC	_HercGraphMode
_HercGraphMode	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp
		push	si
		push	di

; Aggiorna area dati BIOS di visualizzazione con valori corretti

		mov	ax,40h
		mov	es,ax
		mov	di,49h		; ES:DI := 0040:0049 (area dati BIOS)

		mov	si,offset DGROUP:BIOSData
		mov	cx,BIOSDataLen
		rep	movsb		; aggiorna area dati BIOS

; Imposta switch configurazione

		mov	dx,3BFh		; DX := porta dello switch di configurazione
		mov	al,1		; AL bit 1 := 0 (esclude secondi 32K del
					;		buffer del video)
					; AL bit 0 := 1 (permette impostazione
		out	dx,al		;	modalit grafica tramite 3B8h)

; Cancella schermo per evitare interferenze durante programmazione CRTC

		mov	dx,3B8h		; DX := porta reg. di contr. modal. CRTC
		xor	al,al		; AL bit 3 := 0 (disabilita segnale video)
		out	dx,al		; cancella lo schermo

; Programma il CRTC

		sub	dl,4		; DX := porta 3B4h reg. indirizzo CRTC

		mov	si,offset DGROUP:CRTCParms
		mov	cx,CRTCParmsLen

L01:		lodsw			; AL := numero di registro del CRTC
					; AH := dati per questo registro
		out	dx,ax
		loop	L01

; Imposta modalit grafica

		add	dl,4		; DX := 3B8h (reg. controllo modal. CRTC)
		mov	al,CRTMode	; AL bit 1 = 1 (abilita modalit grafica)
					;    bit 3 = 1 (abilita video)
		out	dx,al

		pop	di		; ripristina registri ed esce
		pop	si
		mov	sp,bp
		pop	bp
		ret

_HercGraphMode	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

				; Questi sono i parametri consigliati da Hercules.
				; Sono basati su 16 pixel/carattere e
				;  4 linee di scansione per carattere.

CRTCParms	DB	00h,35h	; Totale orizzontale :  54 caratteri
		DB	01h,2Dh	; Visualizz. orizzontale :  45 caratteri
		DB	02h,2Eh	; Posizione sincron. orizz. :  al 46esimo carattere
		DB	03h,07h	; Ampiezza sincroniz. oriz. :  7 clock di carattere

		DB	04h,5Bh	; Totale vertic. :  92 caratteri (368 linee)
		DB	05h,02h	; Regolaz. vert. :  2 linee di scansione 
		DB	06h,57h	; Visual. vert. :  87 righe di caratteri (348 linee)
		DB	07h,57h	; Posiz. sincr. vertic. :  dopo 87esima riga di carattere

		DB	09h,03h	; Linea scans. max :  4 linee scansione per carattere

CRTCParmsLen	EQU	($-CRTCParms)/2

BIOSData	DB	7	; CRT_MODE
		DW	80	; CRT_COLS
		DW	8000h	; CRT_LEN
		DW	0	; CRT_START
		DW	8 dup(0) ; CURSOR_POSN
		DW	0	; CURSOR_MODE
		DB	0	; ACTIVE_PAGE
CRTCAddr	DW	3B4h	; ADDR_6845
CRTMode		DB	0Ah	; CRT_MODE_SET (valore per porta 3B8h)
		DB	0	; CRT_PALETTE (non usato)

BIOSDataLen	EQU	$-BIOSData

_DATA		ENDS

		END
