		TITLE	'Listato 20'
		NAME	DisplayText
		PAGE	55,132

;
; Nome:		DisplayText
;
; Funzione:	Visualizza una stringa alfanumerica senza interferenze su CGA
;
; Chiamante:	Microsoft C:
;
;			int DisplayText(buf,n,offset);
;
;			char *buf;		/* buffer contenente testo in
;						   formato alfanumerico CGA
;						   (alterna codici carattere
;						   e byte di attributo) */
;
;			int n;			/* lunghezza buffer in byte */
;
;			offset int senza segno ;	/* offset nel buffer del video */
;

ARGbuf		EQU	word ptr [bp+4]
ARGn		EQU	word ptr [bp+6]
ARGoffset	EQU	word ptr [bp+8]
TIMEOUT 	EQU	6		; limite loop di tempo limite orizzontale
VBcount 	EQU	250		; numero di word da scrivere durante
					;  intervallo di soppressione verticale

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	_DisplayText
_DisplayText	PROC	near

		push	bp		; solita premessa C per accedere ai parametri in
		mov	bp,sp		;  stack frame e salvare i registri
		push	si
		push	di

		mov	ax,0B800h
		mov	es,ax
		mov	di,ARGoffset	; ES:DI -> destinazione nel buffer del video
		mov	si,ARGbuf	; DS:SI -> buffer sorgente
		mov	cx,ARGn
		shr	cx,1		; CX := lunghezza buffer in parole

		mov	dx,3DAh		; DX := Porta di stato CGA

; scrive durante restante intervallo di soppressione verticale

L01:		mov	bx,cx		; salva lunghezza buffer in BX
		mov	cx,TIMEOUT	; CX := tempo limite orizzontale
		cli			; disabilita interrupt durante loop

L02:		in	al,dx		; AL := stato video
		test	al,1
		loopnz	L02		; loop mentre 'abilita visualizzazione'  inattivo
		jz	L03		; salta se loop non ha superato tempo limite

		movsw			; copia una word
		sti
		mov	cx,bx		; CX := lunghezza buffer
		loop	L01

		jmp	short L10	; uscita (intera stringa copiata)

; scrive durante intervalli di soppressione orizzontale

L03:		sti
		mov	cx,bx		; ripristina CX

L04:		lodsw			; AL := codice carattere
					; AH := attributo
		mov	bx,ax		; BX := carattere e attributo

		push	cx		; mantiene contatore loop word
		mov	cx,TIMEOUT	; CX := limite loop tempo limite

		cli			; disabilita interrupt durante una linea di scansone
L05:		in	al,dx
		test	al,1
		loopnz	L05		; loop durante soppressione orizzontale
					;  fino a scadere tempo limite
		jnz	L07		; salta se supera tempo limite (
					;  iniziata soppressione verticale)
L06:		in	al,dx
		test	al,1
		jz	L06		; loop mentre  attivo 'abilita visualizzazione'

		xchg	ax,bx		; AX := carattere & attributo
		stosw			; copia 2 byte nel buffer del video

		sti			; riabilita interrupt
		pop	cx		; CX := contatore loop word
		loop	L04

		jmp	short L10	; uscita (intera stringa copiata)

; scrive durante un intero intervallo di soppressione verticale

L07:		pop	bx		; BX := contatore loop word
		dec	si
		dec	si		; DS:SI -> word da copiare dal buffer

		mov	cx,VBcount	; CX := # di word da copiare
		cmp	bx,cx
		jnb	L08		; salta se restano pi di VBcount word
					;  nel buffer
		mov	cx,bx		; CX := # di word restanti nel buffer
		xor	bx,bx		; BX := 0
		jmp	short L09

L08:		sub	bx,cx		; BX := (# di word restanti) - VBcount

L09:		rep	movsw		; copia nel buffer del video

		mov	cx,bx		; CX := # di word restanti
		test	cx,cx
		jnz	L01		; loop fino a visualizzazione buffer terminata

L10:		pop	di		; solito epilogo C per ripristinare i registri
		pop	si		;  ed eliminare stack frame
		mov	sp,bp

		pop	bp
		ret

_DisplayText	ENDP

_TEXT		ENDS

		END
