		TITLE	'Listato 19'
		NAME	DisplayText
		PAGE	55,132

;
; Nome:		DisplayText
;
; Funzione:	Visualizza una stringa alfanumerica senza interferenze su CGA
;
; Chiamante:	Microsoft C:
;
;			int DisplayText1(buf,n,offset);
;
;			char *buf;		/* buffer contenente testo in
;						   formato alfanumerico CGA
;						   (alterna codici carattere
;						   e byte attributo) */
;
;			int n;			/* lunghezza buffer in byte */
;
;			offset int senza segno ;	/* offset nel buffer del video */
;

Set80X25	EQU	(1 SHL 0)	; maschere di bit per reg. controllo modalit
Set320X200	EQU	(1 SHL 1)
BlackAndWhite	EQU	(1 SHL 2)
EnableVideo	EQU	(1 SHL 3)
Set640X200	EQU	(1 SHL 4)
EnableBlink	EQU	(1 SHL 5)

ARGbuf		EQU	word ptr [bp+4]	; indirizzamento parametri in stack frame
ARGn		EQU	word ptr [bp+6]
ARGoffset	EQU	word ptr [bp+8]
TIMEOUT		EQU	6		; limite loop di tempo limite ritracc. oriz.


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	_DisplayText
_DisplayText	PROC	near

		push	bp		; solita premessa C per accedere ai parametri in
		mov	bp,sp		;  stack frame e salvare i registri
		push	si
		push	di

		mov	ax,0B800h
		mov	es,ax
		mov	di,ARGoffset	; ES:DI -> destinazione nel buffer del video 
		mov	si,ARGbuf	; DS:SI -> buffer sorgente
		mov	bx,ARGn
		shr	bx,1		; BX := lunghezza buffer in parole

		mov	dx,3DAh		; DX := Porta di stato del CGA

; attende inizio del periodo di soppressione verticale

L01:		mov	cx,TIMEOUT	; CX := contatore di loop (valore tempo limite)

L02:		in	al,dx		; AL := stato del video
		test	al,8
		jnz	L02		; loop se attivo ritracc. verticale
		test	al,1
		jz	L02		; loop se non attivo ritrac. orizzon.

		cli			; disabilita interrupt durante ritrac. oriz.

L03:		in	al,dx
		test	al,1
		loopnz	L03		; loop fino a conclusione ritrac. o tempo limite

		sti			; riabilita interrupt

		jz	L01		; loop se non  scaduto tempo limite

; cancella lo schermo

		mov	dl,0D8h		; DX := 3D8h (reg. controllo modal.)
		mov	al,(Set80X25 OR EnableBlink)
		out	dx,al		; disattiva video

; copia i dati nel buffer del video 

		mov	cx,bx		; CX := lunghezza buffer in parole
		rep	movsw

; ri-abilita lo schermo

		or	al,EnableVideo
		out	dx,al

		pop	di		; solito epilogo C per ripristinare reg.
		pop	si		;  ed eliminare stack frame
		mov	sp,bp
		pop	bp
		ret

_DisplayText	ENDP

_TEXT		ENDS

		END
