                TITLE   'Listato 26'
		NAME	PixelAddr04
		PAGE	55,132

;
; Nome:		PixelAddr04
;
; Funzione:	Determina indirizzo nel buffer del pixel in modalit 320x200 a 4 colori
;
; Chiamante:	AX = coordinata y (0-199)
;		BX = coordinata x (0-319)
;
; Ritorna:	AH = maschera di bit
;		BX = offset di byte nel buffer
;		CL = numero di bit da spostare verso sinistra
;		ES = segmento buffer del video
;


OriginOffset	EQU	0		; offset in byte di (0,0)
VideoBufferSeg	EQU	0B800h

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	PixelAddr04
PixelAddr04	PROC	near

		mov	cl,bl		; CL := byte meno significativo di x

		xchg	ah,al		; AX := 100h * y
		shr	ax,1		; AL := 80h * (y&1)
		add	bh,al	  	; BX := x + 8000h*(y&1)
		xor	al,al		; AX := 100h*(y/2)
		add	bx,ax	  	; BX := x + 8000h*(y&1) + 100h*(y/2)
		shr	ax,1
		shr	ax,1		; AX := 40h*(y/2)
		add	bx,ax	  	; BX := x + 8000h*(y&1) + 140h*(y/2)
		shr	bx,1
		shr	bx,1	   	; BX := x/4 + 2000h*(y&1) + 50h*(y/2)
		add	bx,OriginOffset	; BX := offset del byte nel buffer del video

		mov	ax,VideoBufferSeg
		mov	es,ax		; ES:BX := indirizzo del byte del pixel

		mov	ah,3		; AH := maschera di bit non spostata
		and	cl,ah		; CL := x & 3
		xor	cl,ah		; CL := 3 - (x & 3)
		shl	cl,1		; CL := # di bit da spostare verso sinistra

		ret

PixelAddr04	ENDP

_TEXT		ENDS

		END
