		TITLE	'Listato 27'
		NAME	PixelAddr06
		PAGE	55,132

;
; Nome:		PixelAddr06
;
; Funzione:	Determina indirizzo nel buffer del pixel nella modalit 640x200 a 2 colori
;
; Chiamante:	AX = coordinata y (0-199)
;		BX = coordinata x (0-639)
;
; Ritorna:	AH = maschera di bit
;		BX = offset del byte nel buffer
;		CL = numero di bit da spostare verso sinistra
;		ES = segmento del buffer del video
;


OriginOffset	EQU	0		; offset del byte di (0,0)
VideoBufferSeg	EQU	0B800h

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	PixelAddr06
PixelAddr06	PROC	near

		mov	cl,bl		; CL := byte meno significativo di x

		xchg	ah,al		; AX := 100h * y
		shr	bx,1		; BX := x/2
		shr	ax,1		; AL := 80h*(y&1)
		add	bh,al	  	; BX := x/2 + 8000h*(y&1)
		xor	al,al		; AX := 100h*(y/2)
		add	bx,ax	  	; BX := x/2 + 8000h*(y&1) + 100h*(y/2)
		shr	ax,1
		shr	ax,1		; AX := 40h*(y/2)
		add	bx,ax	  	; BX := x/2 + 8000h*(y&1) + 140h*(y/2)
		shr	bx,1
		shr	bx,1	   	; BX := x/8 + 2000h*(y&1) + 50h*(y/2)
		add	bx,OriginOffset	; BX := offset del byte nel buffer del video

		mov	ax,VideoBufferSeg
		mov	es,ax		; ES:BX := indirizzo del byte del pixel

		and	cl,7		; CL := x & 7
		xor	cl,7		; CL := numero di bit da spostare a sinistra
		mov	ah,1		; AH := maschera di bit non spostato

		ret

PixelAddr06	ENDP

_TEXT		ENDS

		END
