		TITLE	'Listato 29'
		NAME	PixelAddr10
		PAGE	55,132

;
; Nome:		PixelAddr10
;
; Funzione:	Determina indirizzo di buffer del pixel nelle modalit EGA e VGA originali:
;			16 colori 320x200
;			16 colori 640x200
;			16 colori 640x350
;			monocromatica (4 colori) 640x350
;			2-colori 640x480
;			16-colori 640x480
;
; Chiamante:	AX = coordinata y
;		BX = coordinata x
;
; Ritorna:	AH = maschera di bit
;		BX = offset del byte nel buffer
;		CL = numero di bit da spostare verso sinistra
;		ES = segmento del buffer del video
;


BytesPerLine	EQU	80		; byte in una linea orizzontale
OriginOffset	EQU	0		; offset del byte di (0,0)
VideoBufferSeg	EQU	0A000h

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		PUBLIC	PixelAddr10
PixelAddr10	PROC	near

		mov	cl,bl		; CL := byte meno significativo di x

		push	dx		; mantiene DX

		mov	dx,BytesPerLine	; AX := y * BytesPerLine
		mul	dx

		pop	dx
		shr	bx,1
		shr	bx,1
		shr	bx,1		; BX := x/8
		add	bx,ax		; BX := y*BytesPerLine + x/8
		add	bx,OriginOffset	; BX := offset del byte nel buffer del video

		mov	ax,VideoBufferSeg
		mov	es,ax		; ES:BX := indirizzo del byte del pixel

		and	cl,7		; CL := x & 7
		xor	cl,7		; CL := numero di bit da spostare a sinistra
		mov	ah,1		; AH := maschera di bit non spostato
		ret

PixelAddr10	ENDP

_TEXT		ENDS

		END
