		TITLE	'Listato 43'
		NAME	SetPixel06
		PAGE	55,132

;
; Nome:		SetPixel06
;
; Funzione:	Imposta il valore di un pixel nella modalit a 2 colori 640x200
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate di pixel */
;
;			int n;			/* valore di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr06:near

		PUBLIC	_SetPixel06
_SetPixel06	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr06	; AH := maschera del bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		mov	al,ARGn		; AL := valore di pixel non spostato
		shl	ax,cl		; AH := maschera di bit nella posizione corretta
					; AL := valore di pixel nella posizione corretta

		jmp	word ptr SetPixelOp06	; salta a routine di sostituzione,
						; AND, OR o XOR


					; routine per sostituire valore di pixel

ReplacePixel06:	not	ah		; AH := inverte maschera di bit
		and	es:[bx],ah	; azzera il valore di pixel
		or	es:[bx],al	; imposta il valore di pixel
		jmp	short L02


					; routine per effettuare l'AND del valore del pixel
ANDPixel06:	test	al,al
		jnz	L02		; non esegue nulla se il valore di pixel = 1

L01:		not	ah		; AH := inversione di maschera di bit
		and	es:[bx],ah	; imposta a 0 bit nel buffer del video
		jmp	short L02
				

					; routine per eseguire OR del valore del pixel
ORPixel06:	test	al,al
		jz	L02		; non esegue nulla se valore di pixel = 0

		or	es:[bx],al	; imposta bit nel buffer del video
		jmp	short L02


					; routine per eseguire XOR del valore del pixel
XORPixel06:	test	al,al
		jz	L02		; non esegue nulla se valore di pixel = 0

		xor	es:[bx],al	; esegue XOR del bit nel buffer del video

		
L02:		mov	sp,bp		; ripristina reg. chiamante e ritorna
		pop	bp
		ret

_SetPixel06	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

SetPixelOp06	dw	ReplacePixel06	; contiene indirizzo dell'operazione del pixel

_DATA		ENDS

		END
