		TITLE	'Listato 45'
		NAME	SetPixel10
		PAGE	55,132

;
; Nome:		SetPixel10
;
; Funzione:	Imposta il valore di un pixel nelle modalit grafiche EGA originali.
;
;		*** Modalit di scrittura 0, impostazione/azzeramento ***
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate di pixel */
;
;			int n;			/* valore di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]

RMWbits		EQU	18h		; legge-modifica-scrive bit


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_SetPixel10
_SetPixel10	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare verso sinistra

; imposta registro maschera di bit del controller grafico

		shl	ah,cl		; AH := maschera di bit nella posizione corretta
		mov	dx,3CEh		; porta di registro di indirizzo GC
		mov	al,8		; AL := numero di registro di maschera di bit
		out	dx,ax

; imposta registro modalit controller grafico

		mov	ax,0005h	; AL :=  numero registro modalit
					; AH :=  modalit di scrittura 0 (bit 0,1)
					;	 modalit di lettura 0 (bit 3)
		out	dx,ax

; imposta registro rotazione dati/selezione funzione

		mov	ah,RMWbits	; AH := legge-modifica-scrive bit
		mov	al,3		; AL := reg rotazione dati/selezione funzione
		out	dx,ax

; imposta registri impostazione/azzeramento e abilitazione impostazione/azzeramento

		mov	ah,ARGn		; AH := valore del pixel
		mov	al,0		; AL := numero reg impostazione/azzeramento
		out	dx,ax

		mov	ax,0F01h	; AH := valore per abilit. impostazione/azzeramento (tutti
					;  i piani di bit abilitati)
					; AL := numero reg abilit. impostaz./azzeram.
		out	dx,ax

; imposta il valore di pixel

		or	es:[bx],al	; carica latch durante lettura di CPU
					; aggiorna latch e piani di bit durante
					;  operazione di scrittura di CPU

; ripristina registri di default del controller grafico

		mov	ax,0FF08h	; maschera di bit di default
		out	dx,ax

		mov	ax,0005		; registro di modalit di default
		out	dx,ax

		mov	ax,0003		; selezione funzione di default
		out	dx,ax

		mov	ax,0001		; abilita impostazione/azzeram. di default
		out	dx,ax

		mov	sp,bp		; ripristina registri chiamante e ritorna
		pop	bp
		ret

_SetPixel10	ENDP

_TEXT		ENDS

		END
