		TITLE	'Listato 46'
		NAME	SetPixel10
		PAGE	55,132

;
; Nome:		SetPixel10
;
; Funzione:	Imposta il valore di un pixel nelle modalit grafiche EGA originali.
;
;		*** Modalit di scrittura 0, maschera di mappa del sequencer ***
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate del pixel */
;
;			int n;			/* valore del pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_SetPixel10
_SetPixel10	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

; imposta registro maschera di bit del controller grafico

		shl	ah,cl		; AH := maschera di bit nella posizione corretta
		mov	dx,3CEh		; porta reg indir. controller grafico
		mov	al,8		; AL := numero reg. maschera di bit
		out	dx,ax

; azzera il valore di pixel

		mov	al,es:[bx]	; trasferisce in un latch un byte di ogni piano di bit
		mov	byte ptr es:[bx],0  ; azzera bit mascherati in tutti i piani

; imposta registro maschera di mappa del sequencer

		mov	dl,0C4h		; DX := 3C4h (porta reg indirizzo sequencer)
		mov	ah,ARGn		; AH := valore reg. maschera di mappa
					;  (selezione dei bit non zero nel valore di pixel
					;    abilita piani di bit per sequencer)
		mov	al,2		; AL := numero reg. maschera di mappa
		out	dx,ax

; imposta i bit non zero nel valore di pixel

		mov	byte ptr es:[bx],0FFh ; imposta bit nei piani di bit abilitati

; ripristina registri di default del sequencer

		mov	ah,0Fh		; AH := valore reg maschera di mappa (tutti i piani
					;  di bit abilitati)
		out	dx,ax

; ripristina registri di default del controller grafico

		mov	dl,0CEh		; DX := 3CEh (porta control. grafico)
		mov	ax,0FF08h	; maschera di bit di default
		out	dx,ax

		mov	sp,bp		; ripristina reg. chiamante e ritorna
		pop	bp
		ret

_SetPixel10	ENDP

_TEXT		ENDS

		END
