		TITLE	'Listato 48'
		NAME	SetPixelInC
		PAGE	55,132

;
; Nome:		SetPixelInC
;
; Funzione:	Imposta il valore di un pixel nella modalit a 16 colori 720x348
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate del pixel */
;
;			int n;			/* valore del pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento della cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]

DefaultRWColor	EQU	0Fh		; valore di default per reg. colore lettura/scrittura


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddrHGC:near

		PUBLIC	_SetPixelInC
_SetPixelInC	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddrHGC	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		shl	ah,cl		; AH := maschera di bit nella posizione corretta

		mov	dx,3B4h		; DX := porta CRTC

		jmp	word ptr SetPixelOpInC	; salta a routine di
						;   sostituzione, AND, OR o XOR


ReplacePixelInC:			; routine per sostituire valore di pixel

		mov	ch,ah		; CH := maschera di bit per il pixel
		mov	ax,1F19h	; AH bit 6 := 0 (polarit maschera)
					; AH bit 5-4 := 1 (modalit di scrittra)
					; AH bit 3-0 := bit "ininfluenti"
					; AL := numero registro controllo lettura/scrittura
		out	dx,ax		; imposta reg. controllo lettura/scrittura

		inc	ax		; AL := 1Ah (numero reg colore lettura/scrittura)
		mov	ah,ARGn		; AH := valore primo piano
		out	dx,ax		; imposta reg. colore lettura/scrittura

		and	es:[bx],ch	; aggiorna piani di bit
		jmp	short L01

ANDPixelInC:				; routine per effettuare AND del valore del pixel

		mov	ch,ah		; CH := maschera di bit per il pixel
		mov	ax,1F19h	; AH bit 6 := 0 (polarit maschera)
					; AH bit 5-4 := 1 (modalit di scrittura)
					; AH bit 3-0 := bit "ininfluenti"
					; AL := numero registro controllo lettura/scrittura
		out	dx,ax		; imposta reg. controllo lett./scritt.

		dec	ax		; AL := 18h (numero registro di maschera di piano)
		mov	ah,ARGn		; AH := valore di pixel
		mov	cl,4
		shl	ah,cl		; AH bit 7-4 := maschera di piano scrivibile
		or	ah,0Fh		; AH bit 3-0 := maschera di piano visibile
		out	dx,ax		; imposta reg. di maschera di piano

		mov	ax,001Ah	; AH := 0 (valore di primo piano)
					; AL := 1Ah (reg. colore lett./scritt.)
		out	dx,ax		; imposta registro colore let./scrit.

		and	es:[bx],ch	; aggiorna piani di bit
		jmp	short L01

					; routine per eseguire OR del valore di pixel
ORPixelInC:	
		mov	ch,ah		; CH := maschera di bit per il pixel
		mov	ax,1F19h	; AH bit 6 := 0 (polarit maschera)
					; AH bit 5-4 := 1 (modalit di scrittura)
					; AH bit 3-0 := bit "ininfluenti"
					; AL := numero registro controllo lettura/scrittura
		out	dx,ax		; imposta reg. controllo lett./scrit.

		dec	ax		; AL := 18h (numero registro di maschera di piano)
		mov	ah,ARGn		; AH := valore di pixel
		not	ah		; AH := complemento del valore di pixel
		mov	cl,4
		shl	ah,cl		; AH bit 7-4 := maschera di piano scrivibile
		or	ah,0Fh		; AH bit 3-0 := maschera di piano visibile
		out	dx,ax		; imposta reg. di maschera di piano

		mov	ax,0F1Ah	; AH := 0 (valore di primo piano)
					; AL := 1Ah (reg colore lett./scrit.)
		out	dx,ax		; imposta reg. colore lettura/scritt.

		and	es:[bx],ch	; aggiorna piani di bit
		jmp	short L01

XORPixelInC:				; routine per eseguire XOR del valore di pixel
		mov	ch,ah		; CH := maschera di bit per il pixel
		mov	ax,3F19h	; AH bit 6 := 0 (polarit maschera)
					; AH bit 5-4 := 3 (modalit di scrittura)
					; AH bit 3-0 := bit "ininfluenti"
					; AL := numero registro controllo lettura/scrittura
		out	dx,ax		; imposta reg. controllo lett./scrit.

		dec	ax		; AL := 18h (numero registro di maschera di piano)
		mov	ah,ARGn		; AH := valore di pixel
		not	ah		; AH := complemento del valore di pixel
		mov	cl,4
		shl	ah,cl		; AH bit 7-4 := maschera di piano scrivibile
		or	ah,0Fh		; AH bit 3-0 := maschera di piano visibile
		out	dx,ax		; imposta reg. di maschera di piano

		xor	es:[bx],ch	; aggiorna piani di bit
		jmp	short L01
L01:		mov	ax,0F18h
		out	dx,ax		; ripristina valori di default della maschera di piano

		mov	ax,4019h	; ripristina valore di default controllo lettura/scrittura
		out	dx,ax

		inc	ax		; ripristina valore di default colore lettura/scrittura
		mov	ah,DefaultRWColor
		out	dx,ax

		mov	sp,bp		; ripristina reg. chiamante e ritorna
		pop	bp
		ret

_SetPixelInC	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

SetPixelOpInC   DW      ReplacePixelInc ; contiene indirizzo dell'operazione di pixel

_DATA		ENDS

		END
