		TITLE	'Listato 49'
		NAME	SetPixel11
		PAGE	55,132

;
; Nome:		SetPixel11
;
; Funzione:	Imposta il valore di un pixel nella modalit a 2 colori 640x480 (MCGA o VGA)
;
; Chiamante:	Microsoft C:
;
;			azzera SetPixel(x,y,n);
;
;			int x,y;		/* coordinate del pixel */
;
;			int n;			/* valore del pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento cornice di stack
ARGy		EQU	word ptr [bp+6]
ARGn		EQU	byte ptr [bp+8]


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr10:near

		PUBLIC	_SetPixel11
_SetPixel11	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		mov	al,ARGn		; AL := valore di pixel non spostato
		shl	ax,cl		; AH := maschera di bit nella posizione corretta
					; AL := valore di pixel nella posizione corretta

		jmp	word ptr SetPixelOp11	; salta alla routine di sostituzione,
						;   AND, OR o XOR


					; routine per sostituire il valore di pixel

ReplacePixel11:	not	ah		; AH := inverte maschera di bit
		and	es:[bx],ah	; azzera il valore del pixel
		or	es:[bx],al	; imposta il valore del pixel
		jmp	short L02


					; routine per effettuare AND del valore del pixel
ANDPixel11:	test	al,al
		jnz	L02		; non effettua nulla se valore di pixel = 1

L01:		not	ah		; AH := inversione maschera di bit
		and	es:[bx],ah	; imposta a 0 bit nel buffer del video
		jmp	short L02
				

					; routine per effettuare OR del valore del pixel
ORPixel11:	test	al,al
		jz	L02		; non effettua nulla se valore di pixel = 0

		or	es:[bx],al	; imposta bit nel buffer del video
		jmp	short L02


					; routine per effettuare XOR del valore del pixel
XORPixel11:	test	al,al
		jz	L02		; non effettua nulla se valore di pixel = 0

		xor	es:[bx],al	; effettua XOR del bit nel buffer del video


L02:		mov	sp,bp		; ripristina reg. chiamante e ritorna
		pop	bp
		ret

_SetPixel11	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

SetPixelOp11    DW      ReplacePixel11  ; contiene indirizzo dell'operazione di pixel

_DATA		ENDS

		END
