		TITLE	'Listato 37'
		NAME	ReadPixel10
		PAGE	55,132

;
; Nome:		ReadPixel10
;
; Funzione:	Legge il valore di un pixel nelle modalit grafiche EGA originali
;
; Chiamante:	Microsoft C:
;
;			int ReadPixel10(x,y);
;
;			int x,y;		/* coordinate di pixel */
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento della cornice di stack
ARGy		EQU	word ptr [bp+6]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_ReadPixel10
_ReadPixel10	PROC	near

		push	bp		; mantiene i registri del chiamante
		mov	bp,sp
		push	si

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare

		mov	ch,ah
		shl	ch,cl		; CH := maschera di bit nella posizione corretta

		mov	si,bx		; ES:SI -> byte del buffer
		xor	bl,bl		; BL  usato per accumulare il valore di pixel

		mov	dx,3CEh		; DX := porta del controller grafico
		mov	ax,304h		; AH := numero iniziale di piano di bit
					; AL := numero reg. selezione mappa lettura

L01:		out	dx,ax		; seleziona piano di bit
		mov	bh,es:[si]	; BH := byte del piano di bit corrente
		and	bh,ch		; maschera un bit
		neg	bh		; bit 7 di BH := 1 (se bit mascherato = 1)
					; bit 7 di BH := 0 (se bit mascherato = 0)
		rol	bx,1		; bit 0 di BL := bit succ. del valore di pixel
		dec	ah		; AH := numero piano di bit successivo
		jge	L01

		mov	al,bl		; AL := valore di pixel
		xor	ah,ah		; AX := valore di pixel

		pop	si		; ripristina registri chiamante e ritorna
		mov	sp,bp
		pop	bp
		ret

_ReadPixel10	ENDP

_TEXT		ENDS

		END
