		TITLE	'Listato 40'
		NAME	ReadPixelInC
		PAGE	55,132

;
; Nome:		ReadPixelInC
;
; Funzione:	Legge il valore di un pixel nella modalit a 16 colori 720x348 InColor
;
; Chiamante:	Microsoft C:
;
;			int	ReadPixelInC(x,y);
;
;			int x,y;
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento cornice di stack
ARGy		EQU	word ptr [bp+6]

DefaultRWColor	EQU	0Fh		; valore di default per registro colore lettura/scrittura


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddrHGC:near

		PUBLIC	_ReadPixelInC
_ReadPixelInC	PROC	near

		push	bp		; mantiene registri chiamante
		mov	bp,sp
		push	si

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddrHGC	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare

; impostazione per esaminare separatamente ogni piano di bit

		mov	si,bx		; ES:SI -> buffer

		shl	ah,cl
		mov	cl,ah		; CL := maschera di bit nella posizione corretta

		mov	dx,3B4h		; DX := porta controllo grafico

		mov	ax,0F01Ah	; AH bit 4-7 := 1111b (valore sfondo)
					; AL := 1Ah (reg. colore lettura/scrittura)
		out	dx,ax		; imposta valore sfondo

		mov	bx,800h		; BH := 1000b (bit "ininfluenti" iniziali)
					; BL := 0 (valore iniziale per risultato)

		dec	ax		; AL := 19h (numero registro controllo lettura/scrittura)

; loop attraverso i piani di bit aggiornando i bit "ininfluenti"

L01:		mov	ah,bh		; AH bit 0-3 := successivi bit "ininfluenti"
					; AH bit 6 := 0 (bit polarit maschera)
		xor	ah,1111b	; inverte bit "ininfluenti"
		out	dx,ax		; imposta registro controllo lettura/scrittura

		mov	ch,cl		; CH := maschera di bit
		and	ch,es:[si]	; piani bit di latch
					; CH <> 0 se bit in latch  impostato

		neg	ch		; cf impostato se CH <> 0
		rcl	bl,1		; accumula risultato in BL

		shr	bh,1		; BH := bit "ininfluenti" spostati
		jnz	L01		; loop fino a termine spostamento di BH,
					;  quando BX = valore del pixel
; ripristina stato default

		mov	ah,40h		; AH := valore default registro controllo lettura/scrittura
		out	dx,ax

		inc	ax		; AL := 1Ah (numero registro colore lettura/scrittura)
		mov	ah,DefaultRWColor
		out	dx,ax

		mov	ax,bx		; AX := valore del pixel

		pop	si		; ripristina registri chiamante e ritorna
		mov	sp,bp
		pop	bp
		ret

_ReadPixelInC	ENDP

_TEXT		ENDS

		END
