/* Listato 71 */

struct	EndpointStruct		/* estremit per linea definita */
{
  int	x1,y1;
  int	x2,y2;
};

struct	RegionStruct		/* area rettangolare di definizione */
{
  int	Xul;
  int	Yul;
  int	Xlr;
  int	Ylr;
};


union OutcodeUnion	/* codici esterni rappresentati come campi di bit */
{
  struct
  {
     unsigned code0: 1; 	/* x < Xul */
     unsigned code1: 1; 	/* y < Yul */
     unsigned code2: 1; 	/* x > Xlr */
     unsigned code3: 1; 	/* y > Ylr */
  }
	ocs;

  int	outcodes;
};


#define	X1	ep->x1
#define	Y1	ep->y1
#define	X2	ep->x2
#define	Y2	ep->y2
#define	XUL	r->Xul
#define	YUL	r->Yul
#define	XLR	r->Xlr
#define	YLR	r->Ylr


Clip(ep,r)
struct	EndpointStruct	*ep;
struct	RegionStruct	*r;
{
	union OutcodeUnion	ocu1,ocu2;
	int 	Inside;
	int	Outside;


	/* inizializza codici a 4 bit */

	SetOutcodes( &ocu1, r, X1, Y1 );	/* codici a 4 bit iniziali */
	SetOutcodes( &ocu2, r, X2, Y2 );

	Inside  = ((ocu1.outcodes | ocu2.outcodes) == 0);
	Outside = ((ocu1.outcodes & ocu2.outcodes) != 0);

	while (!Outside && !Inside)
	{
	  if (ocu1.outcodes==0)		/* scambia estremit se necessario in modo che */
	  {				/* (x1,y1) debba essere definito */
	    Swap( &X1, &X2 );
	    Swap( &Y1, &Y2 );
	    Swap( &ocu1, &ocu2 );
	  }


	  if (ocu1.ocs.code0)			/* definisce sinistra */
	  {
	    Y1 += (long)(Y2-Y1)*(XUL-X1)/(X2-X1);
	    X1 = XUL;
	  }

	  else if (ocu1.ocs.code1)		/* definisce sopra */
	  {
	    X1 += (long)(X2-X1)*(YUL-Y1)/(Y2-Y1);
	    Y1 = YUL;
	  }

	  else if (ocu1.ocs.code2)		/* definisce destra */
	  {
	    Y1 += (long)(Y2-Y1)*(XLR-X1)/(X2-X1);
	    X1 = XLR;
	  }

	  else if (ocu1.ocs.code3)		/* definisce sotto */
	  {
	    X1 += (long)(X2-X1)*(YLR-Y1)/(Y2-Y1);
	    Y1 = YLR;
	  }

          SetOutcodes( &ocu1, r, X1, Y1 );	      /* aggiorna per (x1,y1) */

	  Inside  = ((ocu1.outcodes | ocu2.outcodes) == 0); /* aggiorna */
	  Outside = ((ocu1.outcodes & ocu2.outcodes) != 0); /*  codici a 4bit */
	}

	return( Inside );
}

	
SetOutcodes( u, r, x, y )
union OutcodeUnion	*u;
struct RegionStruct	*r;
int	x,y;
{
	u->outcodes = 0;
	u->ocs.code0 = (x < XUL);
	u->ocs.code1 = (y < YUL);
	u->ocs.code2 = (x > XLR);
	u->ocs.code3 = (y > YLR);
}

	
Swap( pa, pb )
int	*pa,*pb;
{
	int	t;

	t = *pa;
	*pa = *pb;
	*pb = t;
}
