		TITLE	'Listato 65'
		NAME	Line04
		PAGE	55,132

;
; Nome:		Line04
;
; Funzione:	Traccia una linea nella modalit a 4 colori 320x200
;
; Chiamante:	Microsoft C:
;
;			azzera Line04(x1,y1,x2,y2,n);
;
;			int x1,y1,x2,y2;	/* coordinate del pixel */
;
;			int n;			/* valore di pixel */
;

ARGx1		EQU	word ptr [bp+4]	; indirizzamento cornice di stack
ARGy1		EQU	word ptr [bp+6]
ARGx2		EQU	word ptr [bp+8]
ARGy2		EQU	word ptr [bp+10]
ARGn		EQU	byte ptr [bp+12]
VARleafincr	EQU	word ptr [bp-2]
VARincr1	EQU	word ptr [bp-4]
VARincr2	EQU	word ptr [bp-6]
VARroutine	EQU	word ptr [bp-8]

ByteOffsetShift	EQU	2		; usato per convertire i pixel all'offset di byte

DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr04:near

		PUBLIC	_Line06
_Line04		PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,8		; spazio di stack per le variabili locali
		push	si
		push	di


		mov	si,2000h	; incremento per intercalazione di buffer del video
		mov	di,80-2000h	; incremento dall'ultima alla prima intercalazione

		mov	cx,ARGx2
		sub	cx,ARGx1	; CX := x2 - x1
		jz	VertLine04	; salta se linea verticale

; forza x1 < x2

		jns	L01		; salta se x2 > x1

		neg	cx		; CX := x1 - x2
		
		mov	bx,ARGx2	; scambia x1 e x2
		xchg	bx,ARGx1
		mov	ARGx2,bx

		mov	bx,ARGy2	; scambia y1 e y2
		xchg	bx,ARGy1
		mov	ARGy2,bx

; calcola dy = ABS(y2-y1)

L01:		mov	bx,ARGy2
		sub	bx,ARGy1	; BX := y2 - y1
		jnz	L02

		jmp	HorizLine04	; salta se linea orizzontale

L02:		jns	L03

		neg	bx		; BX := y1 - y2
		neg	si		; nega incrementi per intercalazione buffer
		neg	di
		xchg	si,di		; scambia incrementi

; seleziona routine appropriata per inclinazione linea

L03:		mov	VARleafincr,di	; salva incremento per intercalazione buffer

		mov	VARroutine,offset LoSlopeLine04
		cmp	bx,cx
		jle	L04		; salta se dy <= dx (inclinazione <= 1)
		mov	VARroutine,offset HiSlopeLine04
		xchg	bx,cx		; scambia dy e dx

; calcola variabile decisionale iniziale e incrementa

L04:		shl	bx,1		; BX := 2 * dy
		mov	VARincr1,bx	; incr1 := 2 * dy
		sub	bx,cx
		mov	di,bx		; DI := d = 2 * dy - dx
		sub	bx,cx
		mov	VARincr2,bx	; incr2 := 2 * (dy - dx)

; calcola primo indirizzo di pixel

		push	cx		; mantiene questo registro
		mov	ax,ARGy1	; AX := y
		mov	bx,ARGx1	; BX := x
		call	PixelAddr04	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		mov	al,ARGn		; AL := valore di pixel non spostato
		shl	ax,cl		; AH := maschera di bit nella posizione corretta
					; AL := valore di pixel nella posizione corretta

		mov	dx,ax		; DH := maschera di bit
					; DL := valore di pixel
		not	dh		; DH := inverte maschera di bit

		pop	cx		; ripristina questo registro
		inc	cx		; CX := # di pixel da tracciare

		test	bx,2000h	; imposta flag zero se BX  nella prima intercalazione
		jz	L05

		xchg	si,VARleafincr	; scambia valori di incremento se il primo pixel
					;  si trova nella prima intercalazione

L05:		jmp	VARroutine	; salta a routine appropriata per inclinazione


; routine per linee verticali

VertLine04:	mov	ax,ARGy1	; AX := y1
		mov	bx,ARGy2	; BX := y2
		mov	cx,bx
		sub	cx,ax		; CX := dy
		jge	L31		; salta se dy >= 0

		neg	cx		; forza dy >= 0
		mov	ax,bx		; AX := y2

L31:		inc	cx		; CX := # di pixel da tracciare
		mov	bx,ARGx1	; BX := x
		push	cx		; mantiene questo registro
		call	PixelAddr04	; AH := maschera di bit
					; ES:BX -> buffer del video
					; CL := # bit da spostare a sinistra
		mov	al,ARGn		; AL := valore di pixel
		shl	ax,cl		; AH := maschera di bit nella posizione corretta
					; AL := valore di pixel nella posizione corretta
		not	ah		; AH := inverte maschera di bit
		pop	cx		; ripristina questo registro

		test	bx,si		; imposta flag zero se BX  nella prima intercalazione
		jz	L32

		xchg	si,di		; scambia valori di incremento se primo pixel
					;  si trova nella prima intercalazione

L32:		and	es:[bx],ah	; azzera pixel nel buffer
		or	es:[bx]al	; imposta valore di pixel nel buffer

		add	bx,si		; incrementa all'area successiva di intercalazione
		xchg	si,di		; commuta tra valori di incremento

		loop	L32		; loop verso il basso della linea
		jmp	Lexit

; routine per linee orizzontali (inclinazione = 0)

HorizLine04:	mov	ax,ARGy1
		mov	bx,ARGx1
		call	PixelAddr04	; AH := maschera di bit
					; ES:BX -> buffer del video
					; CL := # bit da spostare a sinistra
		mov	di,bx		; ES:DI -> buffer

		mov	dh,ah
		not	dh		; DH := maschera di bit non spostata per
					;        byte all'estrema sinistra
		mov	dl,0FFh		; DL := maschera di bit non spostata per
					;	 byte all'estrema destra

		shl	dh,cl		; DH := inverte maschera di bit per primo byte
		not	dh		; DH := maschera di bit per primo byte

		mov	cx,ARGx2
		and	cl,3
		xor	cl,3
		shl	cl,1		; CL := numero di bit da spostare a sinistra
		shl	dl,cl		; DL := maschera di bit per ultimo byte

; determina offset byte del primo e dell'ultimo pixel della linea

		mov	ax,ARGx2	; AX := x2
		mov	bx,ARGx1	; BX := x1

		mov	cl,ByteOffsetShift	; numero di bit da spostare per
						;  convertire i pixel in byte

		shr	ax,cl		; AX := offset di byte di x2
		shr	bx,cl		; BX := offset di byte di x1
		mov	cx,ax
		sub	cx,bx		; CX := (# byte nella linea) - 1

; estende valore di pixel per tutto un byte

		mov	bx,offset DGROUP:PropagatedPixel
		mov	al,ARGn		; AL := valore di pixel
		xlat				; AL := valore di pixel esteso

; imposta pixel nel byte all'estrema sinistra della linea

		or	dh,dh
		js	L43		; salta se  allineato al byte (x1  il pixel
					;  all'estrema sinistra nel byte)
		or	cx,cx
		jnz	L42		; salta se c' pi di un byte nella linea

		and	dl,dh		; maschera di bit per la linea
		jmp	short L44

L42:		mov	ah,al
		and	ah,dh		; AH := bit mascherati di pixel
		not	dh		; DH := inverte maschera di bit per primo byte
		and	es:[di],dh	; azzera pixel mascherati nel buffer
		or	es:[di],ah	; aggiorna pixel mascherati nel buffer
		inc	di
		dec	cx

; usa una veloce istruzione macchina 8086 per tracciare il resto della linea

L43:		rep	stosb		; aggiorna tutti i pixel nella linea

; imposta pixel nel byte all'estrema destra della linea

L44:		and	al,dl		; AL := pixel mascherati per ultimo byte
		not	dl
		and	es:[di],dl	; azzera pixel mascherati nel buffer
		or	es:[di],al	; aggiorna pixel mascherati nel buffer

		jmp	Lexit


; routine per dy <= dx (inclinazione <= 1)	; ES:BX -> buffer del video
                                        ; CX = # pixel da tracciare
					; DH = inverte maschera di bit
					; DL = valore di pixel nella posizione corretta
					; SI = incremento dell'intercalazione del buffer
					; DI = variabile decisionale
LoSlopeLine04:

L10:		mov	ah,es:[bx]	; AH := byte del buffer del video

L11:		and	ah,dh		; azzera valore di pixel all'offset corrente di bit
		or	ah,dl		; imposta valore di pixel nel byte

		ror	dl,1		; ruota valore di pixel
		ror	dl,1
		ror	dh,1		; ruota maschera di bit
		ror	dh,1
		jnc	L14		; salta se maschera di bit  stata ruotata sulla
					;  posizione di pixel all'estrema sinistra

; maschera di bit non spostata fuori

		or	di,di		; test del segno di d
		jns	L12		; salta se d >= 0

		add	di,VARincr1	; d := d + incr1
		loop	L11

		mov	es:[bx],ah	; memorizza restanti pixel nel buffer
		jmp	short Lexit

L12:		add	di,VARincr2	; d := d + incr2
		mov	es:[bx],ah	; aggiorna buffer

		add	bx,si		; incrementa y
		xchg	si,VARleafincr	; scambia valori di incremento intercalazione
		loop	L10
		jmp	short Lexit

; maschera di bit spostata fuori

L14:		mov	es:[bx],ah	; aggiorna buffer
		inc	bx		; BX := offset del byte successivo

		or	di,di		; test del segno di d
		jns	L15		; salta se non negativo

		add	di,VARincr1	; d := d + incr1
		loop	L10
		jmp	short Lexit

L15:		add	di,VARincr2	; d := d + incr2

		add	bx,si		; incrementa y
		xchg	si,VARleafincr

		loop	L10
		jmp	short Lexit


; routine per dy > dx (inclinazione> 1)	; ES:BX -> buffer del video
                                        ; CX = # pixel da tracciare
					; DH = inverte maschera di bit
					; DL = valore di pixel nella posizione corretta
					; SI = incremento dell'intercalazione del buffer
					; DI = variabile decisionale
HiSlopeLine04:

L21:		and	es:[bx],dh	; azzera valore di pixel nel buffer del video
		or	es:[bx],dl	; imposta valore di pixel nel byte

		add	bx,si		; incrementa y
		xchg	si,VARleafincr	; scambia valori di incremento intercalazione

L22:		or	di,di		; test del segno di d
		jns	L23		; salto se d >= 0

		add	di,VARincr1	; d := d + incr1
		loop	L21

		jmp	short Lexit


L23:		add	di,VARincr2	; d := d + incr2

		ror	dl,1		; ruota valore di pixel
		ror	dl,1
		ror	dh,1		; ruota maschera di bit
		ror	dh,1
		cmc			; cf impostato se maschera di bit non  stata ruotata su
					;  posizione di pixel all'estrema sinistra

		adc	bx,0		; BX := offset del byte successivo

		loop	L21


Lexit:		pop	di		; ripristina registri e ritorna
		pop	si
		mov	sp,bp
		pop	bp
		ret

_Line04		ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

PropagatedPixel	DB	00000000b	; 0
		DB	01010101b	; 1
		DB	10101010b	; 2
		DB	11111111b	; 3

_DATA		ENDS

		END
