		TITLE	'Listato 67'
		NAME	Line10
		PAGE	55,132

;
; Nome:		Line10
;
; Funzione:	Traccia una linea nelle seguenti modalit grafiche EGA e VGA:
;			modalit a 16 colori 200 linee
;			modalit a 350 linee
;			modalit a 16 colori 640x480
;
; Chiamante:	Microsoft C:
;
;			azzera Line10(x1,y1,x2,y2,n);
;
;			int x1,y1,x2,y2;	/* coordinate del pixel */
;
;			int n;			/* valore di pixel */
;

ARGx1		EQU	word ptr [bp+4]	; indirizzamento cornice di stack
ARGy1		EQU	word ptr [bp+6]
ARGx2		EQU	word ptr [bp+8]
ARGy2		EQU	word ptr [bp+10]
ARGn		EQU	byte ptr [bp+12]
VARvertincr	EQU	word ptr [bp-2]
VARincr1	EQU	word ptr [bp-4]
VARincr2	EQU	word ptr [bp-6]
VARroutine	EQU	word ptr [bp-8]

ByteOffsetShift	EQU	3		; usato per convertire i pixel in offset di byte
BytesPerLine	EQU	80
RMWbits		EQU	0		; valore per reg rotazione dati/selezione funzione


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_Line10
_Line10		PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,8		; spazio di stack per le variabili locali
		push	si
		push	di

; configura il controller grafico

		mov	dx,3CEh		; DX := indirizzo di porta controller grafico

		mov	ah,ARGn		; AH := valore di pixel
		xor	al,al		; AL := numero registro impostaz./azzeram.
		out	dx,ax

		mov	ax,0F01h	; AH := 1111b (maschera di piano di bit per
					;  abilitaz. impostaz./azzer.
		out	dx,ax		; AL := # reg abilit. impost./azzer.

		mov	ah,RMWbits	; bit 3 e 4 di AH := funzione
		mov	al,3		; AL := # reg rotazione dati/selezione funzione
		out	dx,ax
		
; verifica linea verticale

		mov	si,BytesPerLine	; incrementa per buffer video

		mov	cx,ARGx2
		sub	cx,ARGx1	; CX := x2 - x1
		jz	VertLine10	; salta se linea verticale

; forza x1 < x2

		jns	L01		; salta se x2 > x1

		neg	cx		; CX := x1 - x2
		
		mov	bx,ARGx2	; scambia x1 e x2
		xchg	bx,ARGx1
		mov	ARGx2,bx

		mov	bx,ARGy2	; scambia y1 e y2
		xchg	bx,ARGy1
		mov	ARGy2,bx

; calcola dy = ABS(y2-y1)

L01:		mov	bx,ARGy2
		sub	bx,ARGy1	; BX := y2 - y1
		jz	HorizLine10	; salta se linea orizzontale

		jns	L03		; salta se inclinazione  positiva

		neg	bx		; BX := y1 - y2
		neg	si		; nega incremento per interc. buffer

; seleziona routine appropriata per inclinazione linea

L03:		mov	VARvertincr,si	; salva incremento verticale

		mov	VARroutine,offset LoSlopeLine10
		cmp	bx,cx
		jle	L04		; salta se dy <= dx (inclinaz. <= 1)
		mov	VARroutine,offset HiSlopeLine10
		xchg	bx,cx		; scambia dy e dx

; calcola variabile decisionale iniziale e incrementa

L04:		shl	bx,1		; BX := 2 * dy
		mov	VARincr1,bx	; incr1 := 2 * dy
		sub	bx,cx
		mov	si,bx		; SI := d = 2 * dy - dx
		sub	bx,cx
		mov	VARincr2,bx	; incr2 := 2 * (dy - dx)

; calcola primo indirizzo di pixel

		push	cx		; mantiene questo registro
		mov	ax,ARGy1	; AX := y
		mov	bx,ARGx1	; BX := x
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		mov	di,bx		; ES:DI -> buffer
		shl	ah,cl		; AH := maschera di bit nella posizione corretta
		mov	bl,ah		; AH,BL := maschera di bit
		mov	al,8		; AL := numero reg. maschera di bit

		pop	cx		; ripristina questo registro
		inc	cx		; CX := # di pixel da tracciare

		jmp	VARroutine	; salta a routine appropriata per inclinazione


; routine per linee verticali

VertLine10:	mov	ax,ARGy1	; AX := y1
		mov	bx,ARGy2	; BX := y2
		mov	cx,bx
		sub	cx,ax		; CX := dy
		jge	L31		; salta se dy >= 0

		neg	cx		; forza dy >= 0
		mov	ax,bx		; AX := y2

L31:		inc	cx		; CX := # di pixel da tracciare
		mov	bx,ARGx1	; BX := x
		push	cx		; mantiene questo registro
		call	PixelAddr04	; AH := maschera di bit
					; ES:BX -> buffer del video
					; CL := # bit da spostare a sinistra
; imposta controller grafico

		shl	ah,cl		; AH := maschera di bit nella posizione corretta
		mov	al,8		; AL := numero reg maschera di bit
		out	dx,ax

		pop	cx		; ripristina questo registro

; traccia la linea

L32:		or	es:[bx],al	; imposta il pixel
		add	bx,si		; incrementa a linea successiva
		loop	L32

		jmp	Lexit



; routine per linee orizzontali (inclinazione = 0)

HorizLine10:
		push	ds		; mantiene DS

		mov	ax,ARGy1
		mov	bx,ARGx1
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer del video
					; CL := # bit da spostare a sinistra
		mov	di,bx		; ES:DI -> buffer

		mov	dh,ah		; DH := maschera di bit non spostata per
					;        byte all'estrema sinistra
		not	dh
		shl	dh,cl		; DH := inverte maschera di bit per primo byte
		not	dh		; DH := maschera di bit per primo byte

		mov	cx,ARGx2
		and	cl,7
		xor	cl,7		; CL := numero di bit da spostare a sinistra
		mov	dl,0FFh		; DL := maschera di bit non spostata per
					;	 byte all'estrema destra
		shl	dl,cl		; DL := maschera di bit per ultimo byte

; determina offset byte del primo e dell'ultimo pixel della linea

		mov	ax,ARGx2	; AX := x2
		mov	bx,ARGx1	; BX := x1

		mov	cl,ByteOffsetShift	; numero di bit da spostare per
						;  convertire i pixel in byte

		shr	ax,cl		; AX := offset di byte di x2
		shr	bx,cl		; BX := offset di byte di x1
		mov	cx,ax
		sub	cx,bx		; CX := (# byte nella linea) - 1

; rileva indirizzo di porta del controller grafico da DX

		mov	bx,dx		; BH := maschera di bit del primo byte
					; BL := maschera di bit dell'ultimo byte
		mov	dx,3CEh		; DX := porta del controller grafico
		mov	al,8		; AL := numero reg. maschera di bit

; rende indirizzabile il buffer del video tramite DS:SI

		push	es
		pop	ds
		mov	si,di		; DS:SI -> buffer del video

; imposta pixel nel byte all'estrema sinistra della linea

		or	bh,bh
		js	L43		; salta se  allineato al byte (x1  il pixel
					;   all'estrema sinistra nel byte)
		or	cx,cx
		jnz	L42		; salta se c' pi di un byte nella linea

		and	bl,bh		; maschera di bit per la linea
		jmp	short L44

L42:		mov	ah,bh		; AH := maschera di bit per primo byte
		out	dx,ax		; aggiorna controller grafico

		movsb			; aggiorna piani di bit
		dec	cx

; usa una veloce istruzione macchina 8086 per tracciare il resto della linea

L43:		mov	ah,11111111b	; AH := maschera di bit
		out	dx,ax		; aggiorna reg. di maschera di bit

		rep	movsb		; aggiorna tutti i pixel della linea

; imposta i pixel nel byte all'estrema destra della linea

L44:		mov	ah,bl		; AH := maschera di bit dell'ultimo byte
		out	dx,ax		; aggiorna controller grafico

		movsb			; aggiorna piani di bit

		pop	ds		; ripristina DS
		jmp	short Lexit


; routine per dy <= dx (inclinazione <= 1)	; ES:DI -> buffer del video
					; AL = numero reg. di maschera di bit
					; BL = maschera di bit per primo pixel
					; CX = # pixel da tracciare
					; DX = indirizzo porta controller grafico
					; SI = variabile decisionale
LoSlopeLine10:

L10: 		mov	ah,bl		; AH := maschera di bit per pixel successivo

L11:		or	ah,bl		; maschera posizione corrente del pixel
		ror	bl,1		; ruota valore di pixel
		jc	L14		; salta se maschera di bit  stata ruotata
					;  su posizione pixel all'estrema sinistra

; maschera di bit non spostata fuori

		or	si,si		; test del segno di d
		jns	L12		; salta se d >= 0

		add	si,VARincr1	; d := d + incr1
		loop	L11

		out	dx,ax		; aggiorna reg. di maschera di bit
		or	es:[di],al	; imposta pixel restante(i)
		jmp	short Lexit

L12:		add	si,VARincr2	; d := d + incr2
		out	dx,ax		; aggiorna registro di maschera di bit

		or	es:[di],al	; aggiorna piani di bit

		add	di,VARvertincr	; incrementa y
		loop	L10
		jmp	short Lexit

; maschera di bit spostata fuori

L14:		out	dx,ax		; aggiorna registro di maschera di bit ...

		or	es:[di],al	; aggiorna piani di bit
		inc	di		; incrementa x

		or	si,si		; test del segno di d
		jns	L15		; salta se non negativo

		add	si,VARincr1	; d := d + incr1
		loop	L10 
		jmp	short Lexit

L15:		add	si,VARincr2	; d := d + incr2
		add	di,VARvertincr	; incremento verticale
		loop	L10
		jmp	short Lexit


; routine per dy > dx (inclinazione > 1)	; ES:DI -> buffer del video
					; AH = maschera di bit per primo pixel
					; AL = numero reg. di maschera di bit
					; CX = # pixel da tracciare
					; DX = indirizzo porta controller grafico
					; SI = variabile decisionale
HiSlopeLine10:
		mov	bx,VARvertincr	; BX := incremento y

L21:		out	dx,ax		; aggiorna registro maschera di bit
		or	es:[di],al	; aggiorna piani di bit

		add	di,bx		; incrementa y

L22:		or	si,si		; test del segno di d
		jns	L23		; salta se d >= 0

		add	si,VARincr1	; d := d + incr1
		loop	L21
		jmp	short Lexit


L23:		add	si,VARincr2	; d := d + incr2

		ror	ah,1		; ruota maschera di bit
		adc	di,0		; incrementa DI se maschera  stata ruotata su
					;  posizione di pixel all'estrema destra

		loop	L21


; ripristina stato di default del controller grafico e ritorna al chiamante

Lexit:		xor	ax,ax		; AH := 0, AL := 0
		out	dx,ax		; ripristina reg. impostaz./azzeram.

		inc	ax		; AH := 0, AL := 1
		out	dx,ax		; ripristina reg. abilitazione impostazione/azzeramento

		mov	al,3		; AH := 0, AL := 3
		out	dx,ax		; AL := # reg rotazione dati/selezione funzione

		mov	ax,0FF08h	; AH := 1111111b, AL := 8
		out	dx,ax		; ripristina registro maschera bit

		pop	di		; ripristina registri e ritorna
		pop	si
		mov	sp,bp
		pop	bp
		ret

_Line10		ENDP

_TEXT		ENDS

		END
