		TITLE	'Listato 69'
		NAME	Line13
		PAGE	55,132

;
; Nome:		Line13
;
; Funzione:	Traccia una linea nella modalit a 256 colori 320x200 MCGA/VGA
;
; Chiamante:	Microsoft C:
;
;			azzera Line13(x1,y1,x2,y2,n);
;
;			int x1,y1,x2,y2;	/* coordinate del pixel */
;
;			int n;			/* valore di pixel */
;

ARGx1		EQU	word ptr [bp+4]	; indirizzamento cornice di stack
ARGy1		EQU	word ptr [bp+6]
ARGx2		EQU	word ptr [bp+8]
ARGy2		EQU	word ptr [bp+10]
ARGn		EQU	byte ptr [bp+12]
VARincr1	EQU	word ptr [bp-2]
VARincr2	EQU	word ptr [bp-4]
VARroutine	EQU	word ptr [bp-6]

BytesPerLine	EQU	320

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr13:near

		PUBLIC	_Line13
_Line13		PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,6		; spazio di stack per le variabili locali
		push	si
		push	di

; verifica se si tratta di linea verticale

		mov	si,BytesPerLine	; SI := incremento y iniziale

		mov	cx,ARGx2
		sub	cx,ARGx1	; CX := x2 - x1
		jz	VertLine13	; salta se linea verticale

; forza x1 < x2

		jns	L01		; salta se x2 > x1

		neg	cx		; CX := x1 - x2
		
		mov	bx,ARGx2	; scambia x1 e x2
		xchg	bx,ARGx1
		mov	ARGx2,bx

		mov	bx,ARGy2	; scambia y1 e y2
		xchg	bx,ARGy1
		mov	ARGy2,bx

; calcola dy = ABS(y2-y1)

L01:		mov	bx,ARGy2
		sub	bx,ARGy1	; BX := y2 - y1
		jz	HorizLine13	; salta se linea orizzontale

		jns	L03		; salta se inclinazione  positiva

		neg	bx		; BX := y1 - y2
		neg	si		; nega incremento y

; seleziona routine appropriata per inclinazione linea

L03:		push	si		; mantiene incremento y

		mov	VARroutine,offset LoSlopeLine13
		cmp	bx,cx
		jle	L04		; salta se dy <= dx (inclinazione <= 1)
		mov	VARroutine,offset HiSlopeLine13
		xchg	bx,cx		; scambia dy e dx

; calcola variabile decisionale iniziale e incrementa

L04:		shl	bx,1		; BX := 2 * dy
		mov	VARincr1,bx	; incr1 := 2 * dy
		sub	bx,cx
		mov	si,bx		; SI := d = 2 * dy - dx
		sub	bx,cx
		mov	VARincr2,bx	; incr2 := 2 * (dy - dx)

; calcola primo indirizzo di pixel

		push	cx		; mantiene questo registro
		mov	ax,ARGy1	; AX := y
		mov	bx,ARGx1	; BX := x
		call	PixelAddr13	; ES:BX -> buffer

		mov	di,bx		; ES:DI -> buffer

		pop	cx		; ripristina questo registro
		inc	cx		; CX := # di pixel da tracciare

		pop	bx		; BX := incremento y
		jmp	VARroutine	; salta a routine appropriata per inclinazione


; routine per linee verticali

VertLine13:	mov	ax,ARGy1	; AX := y1
		mov	bx,ARGy2	; BX := y2
		mov	cx,bx
		sub	cx,ax		; CX := dy
		jge	L31		; salta se dy >= 0

		neg	cx		; forza dy >= 0
		mov	ax,bx		; AX := y2

L31:		inc	cx		; CX := # di pixel da tracciare
		mov	bx,ARGx1	; BX := x
		push	cx		; mantiene questo registro
		call	PixelAddr13	; ES:BX -> buffer del video
		pop	cx

		mov	di,bx		; ES:DI -> buffer del video
		dec	si		; SI := byte/linea -1

		mov	al,ARGn		; AL := valore di pixel

L32:		stosb			; imposta valore di pixel nel buffer
		add	di,si		; incrementa a riga successiva
		loop	L32

		jmp	Lexit


; routine per linee orizzontali (inclinazione = 0)

HorizLine13:
		push	cx		; mantiene CX
		mov	ax,ARGy1
		mov	bx,ARGx1
		call	PixelAddr13	; ES:BX -> buffer del video
		mov	di,bx		; ES:DI -> buffer

		pop	cx
		inc	cx		; CX := numero di pixel da tracciare

		mov	al,ARGn		; AL := valore di pixel

		rep	stosb		; aggiorna il buffer del video

		jmp	short Lexit


; routine per dy <= dx (inclinazione <= 1)	; ES:DI -> buffer del video
					; BX = incremento y
                                        ; CX = # pixel da tracciare
					; SI = variabile decisionale
LoSlopeLine13:

		mov	ARGn		; AL := valore del pixel

L11:		stosb			; memorizza pixel, incrementa x

		or	si,si		; test del segno di d
		jns	L12		; salta se d >= 0

		add	si,VARincr1	; d := d + incr1
		loop	L11
		jmp	short Lexit

L12:		add	si,VARincr2	; d := d + incr2
		add	di,bx		; incrementa y
		loop	L11
		jmp	short Lexit


; routine per dy > dx (inclinazione > 1)	; ES:DI -> buffer del video
					; BX = incremento y
                                        ; CX = # pixel da tracciare
					; SI = variabile decisionale

HiSlopeLine13:

		mov	al,ARGn	; AL := valore di pixel
L21:		stosb			; aggiorna pixel successivo, incrementa x

		add	di,bx		; incrementa y

L22:		or	si,si		; test del segno di d
		jns	L23		; salto se d >= 0

		add	si,VARincr1	; d := d + incr1
		dec	di		; decrementa x (gi incrementato da stosb)
		loop	L21
		jmp	short Lexit


L23:		add	si,VARincr2	; d := d + incr2

		loop	L21


Lexit:		pop	di		; ripristina registri e ritorna
		pop	si
		mov	sp,bp
		pop	bp
		ret

_Line13		ENDP

_TEXT		ENDS

			END
