		TITLE	'Listato 75'
		NAME	Ellipse10
		PAGE	55,132

;
; Nome:		Ellipse10
;
; Funzione:	Traccia un'ellisse nelle modalit grafiche originali EGA/VGA.
;
; Chiamante:	Microsoft C:
;
;			azzera Ellipse10(xc,yc,a,b,n);
;
;			int xc,yc;		/* centro dell'ellisse */
;
;			int a,b;		/* assi principale e secondario */
;
;			int n;			/* valore di pixel */
;

ARGxc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGyc		EQU	word ptr [bp+6]
ARGa		EQU	word ptr [bp+8]
ARGb		EQU	word ptr [bp+10]
ARGn		EQU	byte ptr [bp+12]

ULAddr		EQU	word ptr [bp-2]
URAddr		EQU	word ptr [bp-4]
LLAddr		EQU	word ptr [bp-6]
LRAddr		EQU	word ptr [bp-8]
LMask		EQU	byte ptr [bp-10]
RMask		EQU	byte ptr [bp-12]

VARd		EQU	word ptr [bp-16]
VARdx		EQU	word ptr [bp-20]
VARdy		EQU	word ptr [bp-24]
Asquared	EQU	word ptr [bp-28]
Bsquared	EQU	word ptr [bp-32]
TwoAsquared	EQU	word ptr [bp-36]
TwoBsquared	EQU	word ptr [bp-40]

RMWbits		EQU	0		; legge-modifica-scrive bit
BytesPerLine	EQU	80


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_Ellipse10
_Ellipse10	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,40		; stabilisce cornice di stack
		push	si
		push	di

; imposta registro di modalit del controller grafico

		mov	dx,3CEh		; DX := porta di I/O control. grafico
		mov	ax,0005h	; AL := numero registro di modalit
					; AH := modal. scrittura 0 (bit 0,1)
		out	dx,ax		;	modalit di lettura 0 (bit 4)

; imposta registro di rotazione dati/selezione funzione

		mov	ah,RMWbits	; AH := legge-modifica-scrive bit
		mov	al,3		; AL := reg rotazione dati/selezione funzione
		out	dx,ax

; imposta registri impostazione/azzeramento e abilitazione impostazione/azzeramento

		mov	ah,ARGn		; AH := valore del pixel
		mov	al,0		; AL := numero reg. impostaz./azzer.
		out	dx,ax

		mov	ax,0F01h	; AH := valore di abilitazione impostazione/azzeramento (tutti
					;  i piani di bit abilitati)
		out	dx,ax		; AL := numero reg abilitazione impostazione/azzeramento

; costanti iniziali

		mov	ax,ARGa
		mul	ax
		mov	Asquared,ax
		mov	Asquared+2,dx	; a^2
		shl	ax,1
		rcl	dx,1
		mov	TwoAsquared,ax
		mov	TwoAsquared+2,dx ; 2*a^2

		mov	ax,ARGb
		mul	ax
		mov	Bsquared,ax
		mov	Bsquared+2,dx	; b^2
		shl	ax,1
		rcl	dx,1
		mov	TwoBsquared,ax
		mov	TwoBsquared+2,dx ; 2*b^2
;
; traccia pixel da (0,b) fino a dy/dx = -1
;

; indirizzo di buffer e mashera di bit iniziali

		mov	ax,BytesPerLine	; AX := lunghezza di linea di buffer di visualizzazione
		mul	ARGb		; AX := offset di byte relativo di b
		mov	si,ax
		mov	di,ax

		mov	ax,ARGyc	; AX := yc
		mov	bx,ARGxc	; BX := xc
		call	PixelAddr10	; AH := maschera di bit
					; ES:BX -> buffer
					; CL := # bit da spostare a sinistra
		mov	ah,1
		shl	ah,cl		; AH := maschera di bit per primo pixel
		mov	LMask,ah
		mov	RMask,ah

		add	si,bx		; SI := offset di (0,b)
		mov	ULAddr,si
		mov	URAddr,si
		sub	bx,di		; AX := offset di (0,-b)
		mov	LLAddr,bx
		mov	LRAddr,bx

; variabili decisionali iniziali

		xor	ax,ax
		mov	VARdx,ax
		mov	VARdx+2,ax	; dx = 0

		mov	ax,TwoAsquared
		mov	dx,TwoAsquared+2
		mov	cx,ARGb
		call	LongMultiply	; esegue moltiplicazione 32 bit per 16 bit
		mov	VARdy,ax
		mov	VARdy+2,dx	; dy = TwoAsquared * b

		mov	ax,Asquared
		mov	dx,Asquared+2	; DX:AX = Asquared
		sar	dx,1
		rcr	ax,1
		sar	dx,1
		rcr	ax,1		; DX:AX = Asquared/4

		add	ax,Bsquared
		adc	dx,Bsquared+2	; DX:AX = Bsquared + Asquared/4
		mov	VARd,ax
		mov	VARd+2,dx

		mov	ax,Asquared
		mov	dx,Asquared+2
		mov	cx,ARGb
		call	LongMultiply	; DX:AX = Asquared*b
		sub	VARd,ax
		sbb	VARd+2,dx	; d = Bsquared - Asquared*b + Asquared/4

; loop fino a che dy/dx >= -1

		mov	bx,ARGb		; BX := coordinata y iniziale

		xor	cx,cx		; CH := 0 (incremento y iniziale)
					; CL := 0 (incremento x iniziale)
L10:		mov	ax,VARdx
		mov	dx,VARdx+2
		sub	ax,VARdy
		sbb	dx,VARdy+2
		jns	L20		; salta se dx>=dy

		call	Set4Pixels

		mov	cx,1		; CH := 0 (incremento y)
					; CL := 1 (incremento x)
		cmp	VARd+2,0
		js	L11		; salta se d < 0

		mov	ch,1		; incremento in direzione y
		dec	bx		; decrementa coordinata y corrente

		mov	ax,VARdy
		mov	dx,VARdy+2
		sub	ax,TwoAsquared
		sbb	dx,TwoAsquared+2 ; DX:AX := dy - TwoAsquared
		mov	VARdy,ax
		mov	VARdy+2,dx	; dy -= TwoAsquared

		sub	VARd,ax
		sbb	VARd+2,dx	; d -= dy

L11:		mov	ax,VARdx
		mov	dx,VARdx+2
		add	ax,TwoBsquared
		adc	dx,TwoBsquared+2 ; DX:AX := dx + TwoBsquared
		mov	VARdx,ax
		mov	VARdx+2,dx	; dx += TwoBsquared

		add	ax,Bsquared
		adc	dx,Bsquared+2	; DX:AX := dx + Bsquared
		add	VARd,ax
		adc	VARd+2,dx	; d += dx + Bsquared

		jmp	L10
;
; traccia pixel da (x,y) corrente fino a y < 0
;

; indirizzo di buffer e maschera di bit iniziali

L20:		push	bx		; mantiene coordinata y corrente
		push	cx		; mantiene incrementi x e y

		mov	ax,Asquared
		mov	dx,Asquared+2
		sub	ax,Bsquared
		sbb	dx,Bsquared+2	; DX:AX := Asquared-Bsquared

		mov	bx,ax
		mov	cx,dx		; CX:BX := (Asquared-Bsquared)

		sar	dx,1
		rcr	ax,1		; DX:AX := (Asquared-Bsquared)/2
		add	ax,bx
		adc	dx,cx		; DX:AX := 3*(Asquared-Bsquared)/2

		sub	ax,VARdx
		sbb	dx,VARdx+2
		sub	ax,VARdy
		sbb	dx,VARdy+2	; DX:AX := 3*(Asquared-Bsquared)/2 - (dx+dy)

		sar	dx,1
		rcr	ax,1		; DX:AX :=
					;  ( 3*(Asquared-Bsquared)/2 - (dx+dy) )/2
		add	VARd,ax
		adc	VARd+2,dx	; aggiorna d

; loop fino a che y < 0

		pop	cx		; CH,CL := incrementi y e x
		pop	bx		; BX := y

L21:		call	Set4Pixels

		mov	cx,100h		; CH := 1 (incremento y)
					; CL := 0 (incremento x)

		cmp	VARd+2,0
		jns	L22		; salta se d >= 0

		mov	cl,1		; incremento in direzione x

		mov	ax,VARdx
		mov	dx,VARdx+2
		add	ax,TwoBsquared
		adc	dx,TwoBsquared+2 ; DX:AX := dx + TwoBsquared
		mov	VARdx,ax
		mov	VARdx+2,dx	; dx += TwoBsquared

		add	VARd,ax
		adc	VARd+2,dx	; d += dx

L22:		mov	ax,VARdy
		mov	dx,VARdy+2
		sub	ax,TwoAsquared
		sbb	dx,TwoAsquared+2 ; DX:AX := dy - TwoAsquared
		mov	VARdy,ax
		mov	VARdy+2,dx	; dy -= TwoAsquared

		sub	ax,Asquared
		sbb	dx,Asquared+2	; DX:AX := dy - Asquared
		sub	VARd,ax
		sbb	VARd+2,dx	; d += Asquared - dy

		dec	bx		; decrementa y
		jns	L21		; loop se y >= 0


; ripristina registri di default del controller grafico

Lexit:		mov	ax,0FF08h	; maschera di bit di default
		mov	dx,3CEh
		out	dx,ax

		mov	ax,0003		; selezione funzione di default
		out	dx,ax

		mov	ax,0001		; abilitaz. impost./azzer. di default
		out	dx,ax

		pop	di		; ripristina registri e ritorna
		pop	si
		mov	sp,bp
		pop	bp
		ret

_Ellipse10	ENDP


Set4Pixels	PROC	near		; richiama con:  CH := incremento y (0, -1)
					;	         CL := incremento x (0, 1)

		push	ax		; mantiene questi registri
		push	bx
		push	dx

		mov	dx,3CEh		; DX := porta del controller grafico

		xor	bx,bx		; BX := 0
		test	ch,ch
		jz	L30		; salta se incremento y= 0

		mov	bx,BytesPerLine	; BX := incremento positivo
		neg	bx		; BX := incremento negativo

L30:		mov	al,8		; AL := numero reg maschera di bit

; pixel a (xc-x,yc+y) e (xc-x,yc-y)

		xor	si,si		; SI := 0
		mov	ah,LMask

		rol	ah,cl		; AH := maschera di bit ruotata orizzontalmente
		rcl	si,1		; SI := 1 se maschera di bit  stata ruotata
		neg	si		; SI := 0 o -1

		mov	di,si		; SI,DI := incremento orizz. sinisro

		add	si,ULAddr	; SI := indirizzo superiore sinistro + incr oriz
		add	si,bx		; SI := nuovo indirizzo superiore sinistro
		add	di,LLAddr
		sub	di,bx		; DI := nuovo indirizzo inferiore sinistro

		mov	LMask,ah	; aggiorna queste variabili
		mov	ULAddr,si
		mov	LLAddr,di

		out	dx,ax		; aggiorna reg. di maschera di bit

		mov	ch,es:[si]	; aggiorna pixel superiore sinistro
		mov	es:[si],ch
		mov	ch,es:[di]	; aggiorna pixel inferiore sinistro
		mov	es:[di],ch


; pixel a (xc+x,yc+y) e (xc+x,yc-y)

		xor	si,si		; SI := 0
		mov	ah,RMask

		ror	ah,cl		; AH := maschera di bit ruotata orizzontalmente
		rcl	si,1		; SI := 1 se maschera di bit  stata ruotata

		mov	di,si		; SI,DI := incremento orizzon. destro

		add	si,URAddr	; SI := indirizzo superiore destro + incr oriz 
		add	si,bx		; SI := nuovo indirizzo superiore destro
		add	di,LRAddr
		sub	di,bx		; DI := nuovo indirizzo inferiore destro

		mov	RMask,ah	; aggiorna queste variabili
		mov	URAddr,si
		mov	LRAddr,di

		out	dx,ax		; aggiorna reg. di maschera di bit

		mov	ch,es:[si]	; aggiorna pixel superiore destro
		mov	es:[si],ch
		mov	ch,es:[di]	; aggiorna pixel inferiore destro
		mov	es:[di],ch

		pop	dx		; ripristina questi registri
		pop	bx
		pop	ax
		ret

Set4Pixels	ENDP


LongMultiply	PROC	near		; Chiamante:	DX = u1 (word pi significativa
					;		 di numero a 32 bit)
					;		AX = u2 (word meno significativa)
					;		CX = v1 (numero a 16 bit)
					; Ritorna:	DX:AX = risultato a 32 bit)

		push	ax		; mantiene u2
		mov	ax,dx		; AX := 
		mul	cx		; AX := word pi signif. del risultato
		xchg	ax,cx		; AX := v1, CX := word pi significativa
		pop	dx		; DX := u2
		mul	dx		; AX := word meno significativa del risultato
					; DX := riporto
		add	dx,cx		; CX := word pi significativa del risultato
		ret

LongMultiply	ENDP

_TEXT		ENDS

		END
