/* Listato 80 */

#define	BLOCKED		1
#define	UNBLOCKED	2
#define	TRUE		1
#define	FALSE		0

struct	BPstruct			/* tabella dei pixel di cornice */
{
	int	x,y;
	int	flag;
}
	BP[3000];			/* (aumenta se necessario) */

int	BPstart;			/* inizio della tabella */
int	BPend = 0;			/* prima cella vuota nella  tabella */
int	FillValue;			/* valore dei pixel nell'area riempita */
int	BorderValue;			/* valore dei pixel nella cornice */


BorderFill( x, y )
int	x,y;
{
	do				/* esegue finch l'intera tabella non  stata passata */
	{
	  TraceBorder( x, y );		/* segue cornice a partire da x,y */
	  SortBP( BP );			/* ordina la tabella di pixel di cornice */
	  ScanRegion( &x, &y );		/* ricerca buchi all'interno */
	}
	while (BPstart < BPend);

	FillRegion();			/* usa la tabella per riempire l'interno */
}


ScanRegion( x, y )
int	*x,*y;
{
	int	i = BPstart;
	int	xr;

	while (i<BPend)
	{
	  if (BP[i].flag == BLOCKED)		/* salta pixel se di blocco */
	    ++i;

	  else
	  if (BP[i].y != BP[i+1].y)		/* salta pixel se ultimo della linea */
	    ++i;

	  else
	  {					/* se c' almeno un pixel da riempire .. */
	    if (BP[i].x < BP[i+1].x-1)		/* .. passa in scansione la linea */
	    {
	      xr = ScanRight( BP[i].x+1, BP[i].y );

	      if (xr<BP[i+1].x)			/* se viene trovato un pixel di cornice .. */
	      {
		*x = xr;			/* .. ritorna le sue coordinate x,y */
		*y = BP[i].y;
		break;
	      }
	    }

	    i += 2;				/* procede superando questa coppia di pixel */
	  }
	}

	BPstart = i;
}


SortBP()			/* usa routine di ordinamento rapido della biblioteca Microsoft C */
{
	int	CompareBP();

	qsort( BP+BPstart, BPend-BPstart, sizeof(struct BPstruct), CompareBP );
}


CompareBP( arg1, arg2 )		/* ritorna -1 se arg1 < arg2 */
struct	BPstruct  *arg1,*arg2;
{
	int	i;

	i = arg1->y - arg2->y;		/* ordina per coordinata y */
	if (i!=0)
	  return( (i<0) ? -1 : 1 );	/* (ritorna -1 se i<0, 1 se i>0) */

	i = arg1->x - arg2->x;		/* ordina per coordinata x */
	if (i!=0)
	  return( (i<0) ? -1 : 1 );

	i = arg1->flag - arg2->flag;	/* ordina per flag */
	  return( (i<0) ? -1 : 1 );
}


FillRegion()
{
	int	i;


	for(i=0; i<BPend;)
	{
	  if (BP[i].flag == BLOCKED)		/* salta pixel se di blocco */
	    ++i;

	  else
	  if (BP[i].y != BP[i+1].y)		/* salta pixel se ultimo della linea */
	    ++i;

	  else
	  {					/* se c' almeno un pixel da riempire .. */
	    if (BP[i].x < BP[i+1].x-1)		/* .. traccia una linea */
	      Line( BP[i].x+1, BP[i].y, BP[i+1].x-1, BP[i+1].y, FillValue );

	    i += 2;
	  }
	}
}


/* routine per seguire la cornice */

struct	BPstruct CurrentPixel;
int	D;				/* direzione corrente di ricerca */
int	PrevD;				/* direzione precedente di ricerca */
int	PrevV;				/* direzione precedente verticale */


TraceBorder( StartX, StartY )
int	StartX,StartY;
{
	int	NextFound;		/* flag */
	int	Done;

/* inizializza */

	CurrentPixel.x = StartX;
	CurrentPixel.y = StartY;

	D = 6;				/* direzione corrente di ricerca */
	PrevD = 8;			/* direzione precedente di ricerca */
	PrevV = 2;			/* direzione pi recente verticale */

/* loop intorno alla cornice fino a ritorno al pixel di partenza */

	do
	{
	  NextFound = FindNextPixel();
	  Done =
	   (CurrentPixel.x == StartX) && (CurrentPixel.y == StartY);
	}
	while (NextFound && !Done);

/* se c' un solo pixel nella cornice, lo aggiunge due volte alla tabella */

	if (!NextFound)				/* il pixel non ha pixel adiacenti */
	{
	  AppendBPList( StartX, StartY, UNBLOCKED );
	  AppendBPList( StartX, StartY, UNBLOCKED );
	}

/* se la direzione dell'ultima ricerca era verso l'alto, aggiunge il pixel iniziale alla tabella */

	else
	if ( (PrevD <= 3) && (PrevD >= 1) )
	  AppendBPList( StartX, StartY, UNBLOCKED );
}	


FindNextPixel( )
{
	int	i;
	int	flag;


	for (i=-1; i<=5; i++)
	{
	  flag = FindBP( (D+i) & 7 );		/* cerca prossimo pixel di cornice */
	  if (flag)				/* flag  TRUE se trovato */
	  {
	    D = (D+i) & 6;			/* (D+i) MOD 2 */
	    break;				/* esce da loop */
	  }
	}

	return(flag);
}


FindBP( d )
int	d;			/* direzione della ricerca del pixel successivo di cornice */
{
	int	x,y;

	x = CurrentPixel.x;
	y = CurrentPixel.y;


	NextXY( &x, &y, d );		/* rileva x,y del pixel nella direzione d */

	if ( BorderValue == ReadPixel( x, y ) )
	{
	  AddBPList( d );		/* aggiunge pixel a x,y alla tabella */
	  CurrentPixel.x = x;		/* pixel a x,y diventa pixel corrente */
	  CurrentPixel.y = y;
	  return( TRUE );
	}

	else
	  return( FALSE );
}


NextXY( x, y, Direction )
int	*x,*y;
int	Direction;
{
	switch( Direction )		/*   3 2 1   */
	{				/*   4   0   */
	  case 1:			/*   5 6 7   */
	  case 2:
	  case 3:

		*y -= 1;		/* verso l'alto */
		break;
	  case 5:
	  case 6:
	  case 7:
		*y += 1;		/* verso il basso */
		break;
	}

	switch(Direction)
	{
	  case 3:
	  case 4:
	  case 5:
		*x -= 1;		/* verso sinistra */
		break;
	  case 1:
	  case 0:
	  case 7:
		*x += 1;		/* verso destra */
		break;
	}
}


AddBPList( d )
int	d;
{
	if (d == PrevD)
	  SameDirection();

	else
	{
	  DifferentDirection( d );
	  PrevV = PrevD;			/* nuova direzione verticale precedente */ 
	}
	
	PrevD = d;				/* nuova direzione di ricerca precedente */
}

SameDirection()
{
	if (PrevD == 0)				/* spostamento verso destra... */
	  BP[BPend-1].flag = BLOCKED;		/*  pixel precedente di blocco */

	else
	if (PrevD != 4)				/* se non  in corso spostamento orizzontale */
	  AppendBPList( CurrentPixel.x, CurrentPixel.y, UNBLOCKED );
}


DifferentDirection( d )
int	d;
{

/* spostamento verso sinistra precedente */

	if (PrevD == 4)
	{
	  if (PrevV == 5)			/* se dall'alto .. */
	    BP[BPend-1].flag = BLOCKED;		/* .. blocco all'estrema destra nella linea */

	  AppendBPList( CurrentPixel.x, CurrentPixel.y, BLOCKED );
	}

/* spostamento precedente verso destra */

	else
	if (PrevD == 0)				/* spostamento precedente verso destra .. */
	{
	  BP[BPend-1].flag = BLOCKED;		/* .. blocco all'estrema destra nella linea */

	  if (d == 7)				/* se linea  iniziata dall'alto */
	    AppendBPList( CurrentPixel.x, CurrentPixel.y, BLOCKED );
	  else
	    AppendBPList( CurrentPixel.x, CurrentPixel.y, UNBLOCKED );
	}

/* spostamento precedente in una direzione verticale */

	else
	{
	  AppendBPList( CurrentPixel.x, CurrentPixel.y, UNBLOCKED );

/* aggiunge pixel due volte se minimo o massimo verticale locale */

	  if ( ( (d>=1) && (d<=3) ) && ( (PrevD >= 5) && (PrevD <= 7) ) ||
	       ( (d>=5) && (d<=7) ) && ( (PrevD >= 1) && (PrevD <= 3) ) )
	    AppendBPList( CurrentPixel.x, CurrentPixel.y, UNBLOCKED );
	}
}


AppendBPList( p, q, f )
int	p,q;			/* coordinate x,y di pixel */
int	f;			/* flag */
{
	BP[BPend].x = p;
	BP[BPend].y = q;
	BP[BPend].flag = f;

	++BPend;		/* incrementa oltre ultimo elemento della tabella */
}


/* routine per passare in scansione una linea per un pixel di cornice */

int	Xmax;			/* maggiore coordinata x di pixel valida */

ScanRight( x, y )
int	x,y;
{
	while ( ReadPixel( x, y ) != BorderValue )
	{
	  ++x;				/* incrementa x */
	  if (x==Xmax)			/* se fine linea nel buffer .. */
	    break;			/* .. esce dal loop */
	}

	return( x );
}
