		TITLE	'Listato 81'
		NAME	ScanRight10
		PAGE	55,132

;
; Nome:		ScanRight10
;
; Funzione:	Ricerca un pixel di un dato valore nelle modalit grafiche a 16 colori EGA/VGA
;
; Chiamante:	Microsoft C:
;
;			int ScanRight10(x,y);
;
;			int x,y;			/* pixel iniziale */
;
;			extern	int BorderValue;	/* valore pixel di cornice */
;
;		Ritorna la coordinata x del pixel di cornice all'estrema destra.
;

ARGx		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGy		EQU	word ptr [bp+6]

ByteOffsetShift	EQU	3		; usato per convertire i pixel in offset di byte
BytesPerLine	EQU	80		; 80 per maggior parte delle modal. grafiche a 16 colori
					;  (40 per modalit 16 colori 320x200)


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr10:near

		PUBLIC	_ScanRight10
_ScanRight10	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		push	si
		push	di

; calcola indirizzo di pixel di (0,y)

		mov	ax,ARGy		; AX := y
		xor	bx,bx		; BX := 0
		call	PixelAddr10	; ES:BX -> buffer
		mov	di,bx		; ES:DI -> buffer

; calcola offset di x nella riga

		mov	ax,ARGx
		mov	si,ax		; SI,AX := x
		mov	cl,ByteOffsetShift
		shr	si,cl		; SI := offset di x nella riga y
		add	di,si		; DI := offset di x nel buffer

; calcola una maschera di bit per il primo byte da ricercare

		mov	cl,al
		and	cl,7		; CL := x & 7
		mov	ch,0FFh
		shr	ch,cl		; CH := maschera di bit per il primo byte ricercato

; configura il controller grafico

		mov	dx,3CEh		; DX := indirizzo di porta del controller grafico

		mov	ah,_BorderValue	; AH := valore di pixel per reg. confronto colore
		mov	al,2		; AL := numero reg confronto colore
		out	dx,ax

		mov	ax,805h		; AH := 00001000b (modalit di lettura 1)
		out	dx,ax		; AL := numero reg modalit

		mov	ax,0F07h	; AH := 00001111b (valore reg confronto colore) 
		out	dx,ax		; AL := numero reg confronto colore

; esamina primo byte per rilevare pixel di cornice

		mov	al,es:[di]	; AL := bit non zero corrispondenti a
					;  pixel di cornice
		inc	di		; ES:DI -> byte successivo da ricercare
		and	al,ch		; applica maschera di bit
		jnz	L01		; salta se trova pixel di cornice

; scorre resto della linea alla ricerca di pixel di cornice

		mov	cx,BytesPerLine
		sub	cx,si		; CX := BytesPerLine - (offset di byte di
					;  pixel iniziale)
		dec	cx		; CX := # di byte da scorrere

		repe	scasb		; ricerca fino a lettura di byte non 0 ; cio
					;  se trova pixel di cornice

; calcola valore x del pixel di cornice

		mov	al,es:[di-1]	; AL := ultimo byte confrontato

L01:		sub	di,bx		; DI := offset del byte oltre a quello che
					;  contiene un pixel di cornice
		mov	cl,ByteOffsetShift
		shl	di,cl		; DI := coordinata x del primo pixel nel byte

		mov	cx,8		; CX := limite di loop

L02:		shl	al,1		; isola primo pixel di cornice
		jc	L03

		loop	L02

L03:		sub	di,cx		; DI := coordinata x del pixel di cornice

; ripristina stato di default del controller grafico e ritorna al chiamante

		mov	ax,2		; AH := 0 (valore di default di confronto colore)
		out	dx,ax		; ripristina reg confronto colore

		mov	al,5		; AH := 0, AL := 5
		out	dx,ax		; ripristina reg modalit

		mov	ax,di		; AX := ritorna valore

		pop	di		; ripristina reg. chiamante e ritorna
		pop	si
		mov	sp,bp
		pop	bp
		ret

_ScanRight10	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

		EXTRN	_BorderValue:byte

_DATA		ENDS

		END
