		TITLE	'Listato 83'
		NAME	DisplayChar06
		PAGE	55,132

;
; Nome:		DisplayChar06
;
; Funzione:	Visualizza un carattere nella modalit a 2 colori 640x200
;
; Chiamante:	Microsoft C:
;
;			azzera DisplayChar06(c,x,y,fgd,bkgd);
;
;			int c;			/* codcie carattere */
;
;			int x,y;		/* pixel superiore sinistro */
;
;			int fgd,bkgd;		/* valori di pixel
;						   di primo piano e di sfondo */
;

ARGc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGx		EQU	word ptr [bp+6]
ARGy		EQU	word ptr [bp+8]
ARGfgd		EQU	byte ptr [bp+10]
ARGbkgd		EQU	byte ptr [bp+12]

VARmask		EQU	[bp-2]
VARtoggle	EQU	[bp-4]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr06:near

		PUBLIC	_DisplayChar06
_DisplayChar06	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,4		; spazio di stack per variabili locali
		push	si
		push	di
		push	ds

; imposta maschera di commutazione pixel di primo piano

		mov	ah,ARGfgd	; AH := 0 o 1 (valore di pixel di primo piano)
		ror	ah,1		; bit pi significativo di AH := 0 o 1
		cwd			; estende bit pi significativo a tutto DX
		not	dx		; DX :=     0 se primo piano = 1
					;     o FFFFh se primo piano = 0
		mov	VARtoggle,dx

; calcola indirizzo primo pixel

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr06	; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		xor	cl,7		; CL := # bit da ruotare a destra

		mov	ax,0FF00h
		ror	ax,cl		; AX := maschera di bit nella posizione corretta
		mov	VARmask,ax

; imposta indirizzamento del buffer del video

		mov	dx,2000h	; incremento per intercal. buffer del video
		mov	di,80-2000h	; incremento dall'ultima alla prima intercalazione

		test	bx,2000h	; imposta flag zero se BX  nella prima intercalazione
		jz	L01

		xchg	di,dx		; scambia valori di incremento se primo pixel
					;  si trova nella prima intercal.

; imposta indirizzamento tabella definizione caratteri

L01:		push	bx		; mantiene indirizzo buffer

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati di
					;  visualizzazione del BIOS
		mov	ch,ds:[85h]	; CH := POINTS (righe di pixel nel carat.)

		xor	ax,ax
		mov	ds,ax		; DS := zero assoluto

		mov	ax,ARGc		; AL := codice di carattere
		cmp	al,80h
		jae	L02

		mov	bx,43h*4	; DS:BX -> vettore int 43h se car. < 80h
		jmp	short L03

L02:		mov	bx,1Fh*4	; DS:BX -> vettore int 1Fh se car. >= 80h
		sub	al,80h		; introduce codice di carattere nella gamma di tabella

L03:		lds	si,ds:[bx]	; DS:SI -> inizio della tabella di caratteri
		mul	ch		; AX := offset nella tabella definizione caratteri
					;  (POINTS * codice carattere)
		add	si,ax		; SI := indirizzo di definizione carattere

		pop	bx		; ripristina indirizzo buffer

		test	cl,cl		; test # bit dsa ruotare
		jnz	L20		; salta se carattere non  allineato al byte


; routine per caratteri allineati al byte

		mov	ah,VARtoggle	; AH := maschera di commutazione primo piano
		xchg	ch,cl		; CX := POINTS
		
L10:		lodsb			; AL := configurazione di bit per riga di pixel successiva
		xor	al,ah		; commuta pixel se primo piano = 0
		mov	es:[bx],al	; memorizza pixel nel buffer

		add	bx,dx		; BX := riga successiva nel buffer
		xchg	di,dx		; scambia incrementi di buffer
		loop	L10
		jmp	short Lexit


; routine per caratteri non allineati al byte

L20:		mov	ax,VARmask
		and	es:[bx],ax	; maschera pixel del carattere nel buffer

		xor	ah,ah
		lodsb			; AX := configurazione di bit per riga di pixel successiva
		xor	al,VARtoggle	; commuta pixel se primo piano = 0

		ror	ax,cl		; ruota pixel in posizione
		or	es:[bx],ax	; memorizza pixel nel buffer

		add	bx,dx		; BX := riga successiva nel buffer
		xchg	di,dx		; scambia incrementi del buffer
		dec	ch
		jnz	L20


Lexit:		pop	ds		; ripristina registri e ritorna
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_DisplayChar06	ENDP

_TEXT		ENDS

		END
