		TITLE	'Listato 84'
		NAME	DisplayChar04
		PAGE	55,132

;
; Nome:		DisplayChar04
;
; Funzione:	Visualizza un carattere nella modalit grafica a 4 colori 320x200
;
; Chiamante:	Microsoft C:
;
;			azzera DisplayChar04(c,x,y,fgd,bkgd);
;
;			int c;			/* codice di carattere */
;
;			int x,y;		/* pixel superiore sinistro */
;
;			int fgd,bkgd;		/* valori di pixel
;						    di primo piano e di sfondo */
;

ARGc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGx		EQU	word ptr [bp+6]
ARGy		EQU	word ptr [bp+8]
ARGfgd		EQU	         [bp+10]
ARGbkgd		EQU	         [bp+12]

VARshift	EQU	word ptr [bp-2]
VARincr		EQU	word ptr [bp-4]


DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP

		EXTRN	PixelAddr04:near

		PUBLIC	_DisplayChar04
_DisplayChar04	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,4		; spazio di stack per variabili locali
		push	si
		push	di
		push	ds

; estende valori di pixel

		mov	bx,offset DGROUP:PropagatedPixel
		mov	al,ARGfgd
		xlat			; estende valore di pixel di primo piano
		mov	ah,al
		mov	ARGfgd,ax

		mov	al,ARGbkgd
		xlat			; estende valore di pixel di sfondo
		mov	ah,al
		mov	ARGbkgd,ax 

; calcola indirizzo primo pixel

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr04	; ES:BX -> buffer
					; CL := # bit da spostare a sinistra
					;  per mascherare il pixel
		mov	ch,0FCh
		shl	ch,cl		; CH := maschera di bit per lato destro del carattere

		xor	cl,6		; CL := 6 - CL (# bit per ruotare carattere
					;  in posizione)
		mov	VARshift,cx

; imposta indirizzamento buffer del video

		mov	di,2000h	; incremento per interc. buffer del video
		mov	VARincr,80-2000h ; incremento da ultima a prima intercalazione

		test	bx,2000h	; imposta flag zero se BX  nella prima intercalazione
		jz	L01

		xchg	VARincr,di	; scambia valori di incremento se primo pixel
					;  si trova nella prima intercal.

; imposta indirizzamento tabella definizione caratteri

L01:		push	bx		; mantiene indirizzo buffer

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati di
					;  visualizzazione del BIOS
		mov	ch,ds:[85h]	; CH := POINTS (righe di pixel nel carattere)

		xor	ax,ax
		mov	ds,ax		; DS := zero assoluto

		mov	ax,ARGc		; AL := codice carattere
		cmp	al,80h
		jae	L02

		mov	bx,43h*4	; DS:BX -> vettore int 43h se car. < 80h
		jmp	short L03

L02:		mov	bx,1Fh*4	; DS:BX -> vettore int 1Fh se car. >= 80h
		sub	al,80h		; introduce codice carattere nella gamma di tabella

L03:		lds	si,ds:[bx]	; DS:SI -> inizio della tabella dei caratteri
		mul	ch		; AX := offset nella tabella definizione caratteri
					;  (POINTS * codice carattere)
		add	si,ax		; SI := indirizzo definizione carattere

		pop	bx		; ripristina indirizzo buffer

		xchg	ch,cl		; CH := # bit da ruotare
					; CL := POINTS
		
		test	ch,ch		; test # bit da ruotare
		jnz	L20		; salta se carattere non  allineato al byte


; routine per caratteri allineati al byte

L10:		lodsb			; AL := configurazione di bit per riga successiva di pixel
		xor	dx,dx		; DX := valore iniziale dei bit raddoppiati
		mov	ah,8		; AH := # di bit nella configurazione

L11:		shr	al,1		; cf := bit meno significativo di AL
		rcr	dx,1		; bit pi significativo di CX := cf
		sar	dx,1		; raddoppia bit pi significativi di DX
		dec	ah		; loop 8 volte
		jnz	L11

		mov	ax,dx		; AX,DX := configuraz. di bit raddoppiati
		and	ax,ARGfgd	; AX := pixel di primo piano
		not	dx
		and	dx,ARGbkgd	; DX := pixel di sfondo

		or	ax,dx		; AX := otto pixel
		xchg	ah,al		; introduce byte nell'ordine corretto
		mov	es:[bx],ax	; aggiorna buffer del video

		add	bx,di		; BX := riga successiva nel buffer
		xchg	di,VARincr	; scambia incrementi del buffer

		loop	L10
		jmp	short Lexit


; routine per caratteri non allineati al byte

L20:		xor	ch,ch		; CX := POINTS

L21:		push	cx		; mantiene CX

		mov	cx,VARshift	; CH := maschera per lato destro del carattere
					; CL := # bit da ruotare

		lodsb			; AL := configurazione di bit per riga successiva di pixel
		xor	dx,dx		; DX := valore iniziale dei bit raddoppiati
		mov	ah,8		; AH := # di bit nella configurazione

L22:		shr	al,1		; DX := raddoppia bit in AL
		rcr	dx,1		;  (come sopra)
		sar	dx,1
		dec	ah
		jnz	L22

		xchg	dh,dl		; DH := bit per met destra del carattere
					; DL := bit per met sinistra del carattere
		mov	ax,dx

		and	ax,ARGfgd	; AX := pixel di primo piano
		not	dx
		and	dx,ARGbkgd	; DX := pixel di sfondo

		or	dx,ax		; DX := otto pixel
		ror	dx,cl		; DH := pixel del lato destro e sinistro
					; DL := pixel di centro
		mov	al,ch
		xor	ah,ah		; AX := maschera dei byte di sinistra e di centro
					;  del carattere
		and	es:[bx],ax	; azzera pixel nel buffer del video

		not	ax
		and	ax,dx
		or	es:[bx],ax	; aggiorna pixel nei byte di sinistra e del centro

		mov	al,ch		; AL := maschera del byte di destra
		not	al
		and	es:[bx+2],al	; maschera pixel nel byte di destra nel buffer
		and	ch,dl
		or	es:[bx+2],ch	; aggiorna pixel nel byte di destra

		add	bx,di		; BX := riga successiva nel buffer
		xchg	di,VARincr	; scambia incrementi del buffer

		pop	cx		; ripristina CX
		loop	L21


Lexit:		pop	ds		; ripristina registri e ritorna
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_DisplayChar04	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

PropagatedPixel	DB	00000000b	; 0
		DB	01010101b	; 1
		DB	10101010b	; 2
		DB	11111111b	; 3

_DATA		ENDS

		END
