		TITLE	'Listato 85'
		NAME	DisplayCharHGC
		PAGE	55,132

;
; Nome:		DisplayCharHGC
;
; Funzione:	Visualizza un carattere nella modalit grafica monocromatica 720x348 Hercules
;
; Chiamante:	Microsoft C:
;
;			azzera DisplayCharHGC(c,x,y,fgd,bkgd);
;
;			int c;			/* codice carattere */
;
;			int x,y;		/* pixel superiore sinistro */
;
;			int fgd,bkgd;		/* valori di pixel
;						   di primo piano e di sfondo */
;

ARGc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGx		EQU	word ptr [bp+6]
ARGy		EQU	word ptr [bp+8]
ARGfgd		EQU	byte ptr [bp+10]
ARGbkgd		EQU	byte ptr [bp+12]

VARmask		EQU	[bp-2]
VARtoggle	EQU	[bp-4]
VAR9bits	EQU	byte ptr [-6]


_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddrHGC:near

		PUBLIC	_DisplayCharHGC
_DisplayCharHGC	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,6		; spazio di stack per variabili locali
		push	si
		push	di
		push	ds

; calcola indirizzo primo pixel

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddrHGC	; ES:BX -> buffer
					; CL := # bit da spostare a sinistra

		xor	cl,7		; CL := # bit da ruotare a destra

; imposta maschera a 8 o 9 bit

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati
					;  di visualizzazione del BIOS

		mov	ax,0FF0h	; AX := maschera a 8 bit
		mov	VAR9bits,0	; azzera questo flag

		cmp	byte ptr ds:[4Ah],90	; CRT_COLS = 90?
		je	L01		; salta se caratteri sono larghi 8 pixel

		mov	ah,7Fh		; AX :=maschera a 9 bit
		cmp	ARGc,0C0h
		jb	L01		; salta se codice carattere ...

		cmp	ARGc,0DFh
		ja	L01		; ...  al di fuori della gamma 0C0-0DFh

		inc	VAR9bits	; imposta flag per estendere a 9 bit

L01:		ror	ax,cl		; AX := maschera di bit nella posizione corretta
		mov	VARmask,ax

; imposta maschera di commutazione pixel di primo piano

		mov	ah,ARGfgd	; AH := 0 o 1 (valore di pixel di primo piano)
		ror	ah,1		; bit pi significativo di AH := 0 o 1
		cwd			; estende bit pi significativo a tutto DX
		not	dx		; DX := 0 se primo piano = 1
					;  o FFFh se primo piano = 0
		mov	ax,VARmask
		not	ax
		and	dx,ax		; azzera bit non utiliz. della maschera di commutaz. di DX
		mov	VARtoggle,dx

; imposta indirizzamento tabella definizione caratteri

		push	bx		; mantiene indirizzo buffer

		mov	ch,ds:[85h]	; CH := POINTS (righe di pixel nel carat.)

		xor	ax,ax
		mov	ds,ax		; DS := zero assoluto

		mov	ax,ARGc		; AL := codice di carattere
		cmp	al,80h
		jae	L02

		mov	bx,43h*4	; DS:BX -> vettore int 43h se car. < 80h
		jmp	short L03

L02:		mov	bx,1Fh*4	; DS:BX -> vettore int 1Fh se car. >= 80h
		sub	al,80h		; introduce codice di carattere nella gamma di tabella

L03:		lds	si,ds:[bx]	; DS:SI -> inizio tabella di caratteri
		mul	ch		; AX := offset nella tabella definiz. car.
					;  (POINTS * codice carattere)
		add	si,ax		; SI := indirizzo di definizione carattere

		pop	bx		; ripristina indirizzo buffer

; maschera e imposta pixel nel buffer del video

L20:		mov	ax,VARmask
		and	es:[bx],ax	; maschera pixel del carattere nel buffer

		xor	ah,ah
		lodsb			; AX := configurazione di bit per riga successiva di pixel
		cmp	VAR9bits,0
		je	L21		; salta se il carattere  largo 8 pixel

		ror	ax,1		; copia bit meno significativo di AX nel ...
		rcl	al,1		;  bit pi significativo

L21:		ror	ax,cl		; ruota pixel in posizione
		xor	ax,VARtoggle	; commuta pixel se primo piano = 0
		or	es:[bx],ax	; memorizza pixel nel buffer

		add	bx,2000h	; incrementa ad area succ. dell'intercal.
		jns	L22

		add	bx,90-8000h	; incrementa alla prima area di intercal.

L22:		dec	ch
		jnz	L20


Lexit:		pop	ds		; ripristina registri e ritorna
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_DisplayChar06	ENDP

_TEXT		ENDS

		END
