		TITLE	'Listato 86'
		NAME	DisplayChar13
		PAGE	55,132

;
; Nome:		DisplayChar13
;
; Funzione:	Visualizza un carattere nella modalit a 256 colori 320x200 MCGA/VGA
;
; Chiamante:	Microsoft C:
;
;			azzera DisplayChar13(c,x,y,fgd,bkgd);
;
;			int c;			/* codice di carattere */
;
;			int x,y;		/* pixel superiore sinistro */
;
;			int fgd,bkgd;		/* valori di pixel
;						   di primo piano e di sfondo */
;

ARGc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGx		EQU	word ptr [bp+6]
ARGy		EQU	word ptr [bp+8]
ARGfgd		EQU	byte ptr [bp+10]
ARGbkgd		EQU	byte ptr [bp+12]

BytesPerLine	EQU	320

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr13:near

		PUBLIC	_DisplayChar13
_DisplayChar13	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		push	si
		push	di
		push	ds

; calcola primo indirizzo di pixel

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr13	; ES:BX -> buffer
		mov	di,bx		; ES:DI -> buffer

; imposta indirizzamento tabella definizione carattere

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati
					;  di visualizzazione del BIOS
		mov	cx,ds:[85h]	; CX := POINTS (righe di pixel nel carat.)

		xor	ax,ax
		mov	ds,ax		; DS := zero assoluto

		mov	ax,ARGc		; AL := codice di carattere
		mov	bx,43h*4	; DS:BX -> vettore int 43h se car. < 80h
		lds	si,ds:[bx]	; DS:SI -> inizio tabella dei caratteri 
		mul	cl		; AX := offset nella tabella di definizione
					;  car. (POINTS * codice carattere)
		add	si,ax		; SI := indirizzo della definiz. carattere
		
; memorizza il carattere nel buffer del video

		mov	bl,ARGfgd	; BL := valore di pixel di primo piano
		mov	bh,ARGbkgd	; BH := valore di pixel di sfondo

L10:		push	cx		; mantiene CX per tutto il loop
		mov	cx,8		; CX := larghezza carattere in pixel
		lodsb
		mov	ah,al		; AH := configurazione di bit per successiva riga di pixel

L11:		mov	al,bl		; AL := valore di pixel di primo piano
		shl	ah,1		; flag del riporto := bit pi significativo
		jc	L12		; salta se configurazione di bit specifica
					;  un pixel di primo piano (bit = 1)
		mov	al,bh		; AL := valore di pixel di sfondo

L12:		stosb			; aggiorna un pixel nel buffer
		loop	L11

		add	di,BytesPerLine-8 ; incrementa indirizzo di buffer
					  ;  a successiva riga di pixel
		pop	cx
		loop	L10		; loop del carattere verso il basso

		pop	ds		; ripristina registri e ritorna
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_DisplayChar13	ENDP

_TEXT		ENDS

		END
