		TITLE	'Listato 87'
		NAME	DisplayChar10
		PAGE	55,132

;
; Nome:		DisplayChar10
;
; Funzione:	Visualizza un carattere nelle modalit grafiche EGA e VGA originali
;
; Chiamante:	Microsoft C:
;
;			azzera DisplayChar10(c,x,y,fgd,bkgd);
;
;			int c;			/* codice di carattere */
;
;			int x,y;		/* pixel superiore sinistro */
;
;			int fgd,bkgd;		/* valori di pixel
;						    di primo piano e di sfondo */
;

ARGc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGx		EQU	word ptr [bp+6]
ARGy		EQU	word ptr [bp+8]
ARGfgd		EQU	byte ptr [bp+10]
ARGbkgd		EQU	byte ptr [bp+12]

VARshift	EQU	         [bp-2]

BytesPerLine	=	80		; (deve essere 40 nella modalit a 16 colori 320x200)
RMWbits		=	18h		; legge-modifica-scrive bit

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddr10:near

		PUBLIC	_DisplayChar10
_DisplayChar10	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,2		; spazio di stack per variabile locale
		push	si
		push	di
		push	ds

; calcola indirizzo di primo pixel

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddr10	; ES:BX -> buffer
					; CL := # bit da spostare a sinistra per
					;  mascherare pixel
		inc	cx
		and	cl,7		; CL := # bit da spostare per mascherare carattere

		mov	ch,0FFh
		shl	ch,cl		; CH := maschera di bit per lato destro del carattere
		mov	VARshift,cx

		push	es		; mantiene segmento del buffer del video
		mov	si,bx		; SI := offset del buffer del video

; imposta indirizzamento tabella definizione carattere

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati
					; di visualizzazione del BIOS
		mov	cx,ds:[85h]	; CX := POINTS (righe di pixel nel carattere)

		xor	ax,ax
		mov	ds,ax		; DS := zero assoluto

		mov	ax,ARGc		; AL := codice di carattere
		mov	bx,43h*4	; DS:BX -> vettore int 43h
		les	di,ds:[bx]	; ES:DI -> inizio tabella dei caratteri
		mul	cl		; AX := offset nella tabella di definizione caratteri
					;  (POINTS * codice del carattere)
		add	di,ax		; DI := indirizzo definiz. carattere

		pop	ds		; DS:SI -> buffer del video

; imposta registri del controller grafico

		mov	dx,3CEh		; porta reg indirizzo controller grafico

		mov	ax,0A05h	; AL :=  numero registro modalit
					; AH :=  modalit scrittura 2 (bit 0-1)
					;	 modalit lettura 1 (bit 4)
		out	dx,ax

		mov	ah,RMWbits	; AH := legge-modifica-scrive bit
		mov	al,3		; AL := reg rotaz. dati/selez. funzione
		out	dx,ax

		mov	ax,0007		; AH := bit colore ininfluente
					; AL := numero reg colore ininfluente
		out	dx,ax		; "ininfluente" per tutti  piani di bit

; seleziona routine di output a seconda che il carattere sia allineato o meno al byte

		mov	bl,ARGfgd	; BL := valore di pixel di primo piano
		mov	bh,ARGbkgd	; BH := valore di pixel di sfondo

		cmp	byte ptr VARshift,0   ; test # bit da spostare
		jne	L20		; salta se carattere non  allineato al byte


; routine per caratteri allineati al byte

		mov	al,8		; AL := numero registro maschera di bit

L10:		mov	ah,es:[di]	; AH := configurazione per riga successiva di pixel
		out	dx,ax		; aggiorna registro di maschera di bit
		and	[si],bl		; aggiorna pixel di primo piano

		not	ah
		out	dx,ax
		and	[si],bh		; aggiorna pixel di sfondo

		inc	di		; ES:DI -> byte success. nella tabella definizione car.
		add	si,BytesPerLine	; incrementa a linea successiva nel buffer del video
		loop	L10
		jmp	short Lexit


; routine per caratteri non allineati al byte

L20:		push	cx		; mantiene contatore di loop
		mov	cx,VARshift	; CH := maschera per lato sinistro del carattere
					; CL := # bit da spostare a sinistra
; lato sinistro del carattere

		mov	al,es:[di]	; AL := bit per riga succes. di pixel
		xor	ah,ah
		shl	ax,cl		; AH := bit per lato sinistro del car.
					; AL := bit per lato destro del carat.
		push	ax		; salva bit per lato destro su stack
		mov	al,8		; AL := numero registro maschera di bit
		out	dx,ax		; imposta maschera di bit per pixel di primo piano

		and	[si],bl		; aggiorna pixel di primo piano

		not	ch		; CH := maschera per lato sinistro del carattere
		xor	ah,ch		; AH := bit per pixel di sfondo
		out	dx,ax		; imposta maschera di bit

		and	[si],bh		; aggiorna pixel di sfondo

; lato destro del carattere

		pop	ax
		mov	ah,al		; AH := bit per lato destro del carat.
		mov	al,8
		out	dx,ax		; imposta maschera di bit

		inc	si		; DS:SI -> lato destro del carattere nel buffer

		and	[si],bl		; aggiorna pixel di primo piano

		not	ch		; CH := maschera per lato destro del carattere
		xor	ah,ch		; AH := bit per pixel di sfondo
		out	dx,ax		; imposta maschera di bit

		and	[si],bh		; aggiorna pixel di sfondo

; incrementa a riga successiva di pixel nel carattere

		inc	di		; ES:DI -> byte success. nella tabella definizione car.
		dec	si
		add	si,BytesPerLine	; DS:SI -> linea successiva nel buffer del video

		pop	cx
		loop	L20


; ripristina registri di default del controller grafico

Lexit:		mov	ax,0FF08h	; maschera di bit di default
		out	dx,ax

		mov	ax,0005		; registro di default di modalit
		out	dx,ax

		mov	ax,0003		; rotaz. dati/selez. funz. di default
		out	dx,ax

		mov	ax,0F07h	; colore ininfluente di default
		out	dx,ax

		pop	ds		; ripristina reg. chiamante e ritorna
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_DisplayChar10	ENDP

_TEXT		ENDS

		END
