		TITLE	'Listato 88'
		NAME	DisplayCharInC
		PAGE	55,132

;
; Nome:		DisplayCharInC
;
; Funzione:	visualizza un carattere nella modalit a 16 colori 720x348 InColor
;
; Chiamante:	Microsoft C:
;
;			azzera DisplayCharInC(c,x,y,fgd,bkgd);
;
;			int c;			/* codice carattere */
;
;			int x,y;		/* pixel superiore sinistro */
;
;			int fgd,bkgd;		/* valori di pixel
;						    di primo piano e di sfondo */
;

ARGc		EQU	word ptr [bp+4]	; indirizzamento di cornice di stack
ARGx		EQU	word ptr [bp+6]
ARGy		EQU	word ptr [bp+8]
ARGfgd		EQU	byte ptr [bp+10]
ARGbkgd		EQU	byte ptr [bp+12]

VARmask		EQU	word ptr [bp-2]
VAR9bits	EQU	byte ptr [bp-4]

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT

		EXTRN	PixelAddrHGC:near

		PUBLIC	_DisplayCharInC
_DisplayCharInC	PROC	near

		push	bp		; mantiene registri del chiamante
		mov	bp,sp
		sub	sp,4		; spazio di stack per variabili locali
		push	si
		push	di
		push	ds

; calcola indirizzo di primo pixel

		mov	ax,ARGy		; AX := y
		mov	bx,ARGx		; BX := x
		call	PixelAddrHGC	; ES:BX -> buffer
					; CL := # bit da spostare a sinistra per
					;  mascherare pixel
		xor	cl,7		; CL := # bit da ruotare a destra

		push	es		; mantiene segmento del buffer del video
		mov	si,bx		; DI := offset del buffer del video

; imposta flag per caratteri a 8 o a 9 bit

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati di
					;  visualizzazione del BIOS

		mov	ax,0FF00h	; AX := maschera a 8 bit
		mov	VAR9bits,0	; azzera questo flag

		cmp	byte ptr ds:[4Ah],90	; CRT_COLS = 90?
		je	L01		; salta se carat. sono larghi 8 pixel

		mov	ah,7Fh		; AX := maschera a 9 bit
		cmp	ARGc,0C0h
		jb	L01		; salta se codice carattere ...

		cmp	ARGc,0DFh
		ja	L01		; ...  fuori dal range 0C0-0DFh

		inc	VAR9bits	; imposta flag per estendere a 9 bit

L01:		ror	ax,cl		; AX := maschera di bit in posizione corretta
		mov	VARmask,ax

; imposta indirizzamento tabella definizione caratteri

		mov	ax,40h
		mov	ds,ax		; DS := segmento dell'area dati
					;  di visualizzazione del BIOS
		mov	ch,ds:[85h]	; CH := POINTS (righe di pixel nel carattere)

		xor	ax,ax
		mov	ds,ax		; DS := zero assoluto

		mov	ax,ARGc		; AL := codice di carattere
		cmp	al,80h
		jae	L02

		mov	bx,43h*4	; DS:BX -> vettore int 43h se car. < 80h
		jmp	short L03

L02:		mov	bx,1Fh*4	; DS:BX -> vettore int 1Fh se car. >= 80h
		sub	al,80h		; introduce codice di carattere nella gamma della tabella

L03:		les	di,ds:[bx]	; ES:DI -> inizio tabellla caratteri
		mul	ch		; AX := offset nella tabella definizione caratteri
					;  (POINTS * codice carattere)
		add	di,ax		; DI := indirizzo della definizione carat.

		pop	ds		; DS:SI -> buffer del video

; imposta registri di controllo

		mov	dx,3B4h		; porta di I/O del reg. di controllo

		push	cx		; mantiene CX
		mov	ah,ARGbkgd	; AH := valore di pixel di sfondo
		mov	cl,4
		shl	ah,cl		; AH bit 4-7 := valore di pixel di sfondo
		or	ah,ARGfgd	; AH bit 0-3 := valore di pixel di primo piano
		pop	cx		; ripristina CX

		mov	al,1Ah		; AL := numero reg colore let./scrit.
		out	dx,ax		; imposta valore colore let./scrit.

; maschera ed imposta pixel nel buffer del video

L20:		xor	bh,bh
		mov	bl,es:[di]	; BX := configuraz. di bit per riga success. di pixel
		inc	di		; incrementa puntatore su tabella definizione caratteri
		cmp	VAR9bits,0

		je	L21		; salta se carattere  largo 8 pixel

		ror	bx,1		; copia bit meno significativo di BX
		rcl	bl,1		;  nel bit pi significativo

L21:		ror	bx,cl		; ruota pixel in posizione

		mov	ax,5F19h	; AH bit 6 := 1 (polarit di maschera)
					; AH bit 4-5 := 01b (modalit di scrittura 1)
					; AH bit 0-3 := 1111b (bit ininfluenti)
					; AL := 19h (reg controllo lettura/scrittura)
		out	dx,ax		; imposta reg controllo let./scrit.

		or	[si],bl		; aggiorna pixel di primo piano
		or	[si+1],bh

		mov	ah,6Fh		; imposta modalit di scrittura 2
		out	dx,ax

		or	bx,VARmask	; BX := configurazione di bit di pixel di sfondo
		or	[si],bl		; aggiorna pixel di sfondo
		or	[si+1],bh

		add	si,2000h	; incrementa ad area successiva di intercalazione
		jns	L22

		add	si,90-8000h	; incrementa alla prima area di intercalazione

L22:		dec	ch
		jnz	L20

; ripristina valori di default dei registri InColor

		mov	ax,4019h	; reg di controllo lettura/scrittura di default
		out	dx,ax

		mov	ax,071Ah	; reg colore lettura/scrittura di default
		out	dx,ax

		pop	ds		; ripristina registri e ritorna
		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_DisplayCharInC	ENDP

_TEXT		ENDS

		END
