		TITLE	'Listato 141'
		NAME	EstablishPSA
		PAGE	55,132

;
; Nome:		EstablishPSA
;
; Funzione:	Stabilisce un'area di salvataggio parametri per il BIOS del video EGA o VGA.
;		Questa area di salvataggio rispecchier i valori correnti dei registri di
;		sovrascansione e di palette del controller di attributo.
;
; Chiamante:	Microsoft C:
;
;			azzera EstablishPSA();
;

SAVE_PTR	EQU	0A8h

DGROUP		GROUP	_DATA

_TEXT		SEGMENT	byte public 'CODE'
		ASSUME	cs:_TEXT,ds:DGROUP,es:DGROUP

		PUBLIC	_EstablishPSA
_EstablishPSA	PROC	near

		push	bp
		mov	bp,sp
		push	si
		push	di

; mantiene precedente SAVE_PTR

		push	ds
		pop	es		; ES -> DGROUP
		mov	di,offset DGROUP:Old_SAVE_PTR

		mov	ax,40h
		mov	ds,ax		; DS -> area dati del BIOS del video
		mov	si,SAVE_PTR	; DS:SI -> SAVE_PTR

		mov	cx,4
		rep	movsb

; copia tabella SAVE POINTER in RAM

		lds	si,es:Old_SAVE_PTR	; DS:SI -> tabella SAVE POINTER
		mov	di,offset DGROUP:SP_TABLE1
		mov	cx,7*4		; numero di byte da spostare
		rep	movsb

; aggiorna SAVE_PTR con indirizzo della nuova tabella SAVE POINTER

		mov	ds,ax		; DS -> area dati del BIOS del video
		mov	si,SAVE_PTR
		mov	word ptr [si],offset DGROUP:SP_TABLE1
		mov	[si+2],es

; aggiorna tabella SAVE POINTER con indirizzo dell'area di salvataggio parametri

		push	es
		pop	ds	; DS -> DGROUP

		mov	word ptr SP_TABLE1[4],offset DGROUP:PSA
		mov	word ptr SP_TABLE1[6],ds

; ripristina registri ed esce

		pop	di
		pop	si
		mov	sp,bp
		pop	bp
		ret

_EstablishPSA	ENDP

_TEXT		ENDS


_DATA		SEGMENT	word public 'DATA'

Old_SAVE_PTR	DD	?		; precedente valore di SAVE_PTR

SP_TABLE1	DD	7 dup(?)	; copia RAM della tabella SAVE POINTER

PSA		DB	256 dup(0)	; area di salvataggio parametri

_DATA		ENDS

		END
