                TITLE   'Listato 1'
                NAME    SetVmode
                PAGE    55,132

;
; Nome:         SetVmode
;
; Funzione:     Richiama BIOS ROM del PC IBM per impostare una modalit di
;               visualizzazione.
;
; Chiamante:    Microsoft C:
;
;                       annulla SetVmode(n);
;
;                       int n;                  /* modalit video */
;

ARGn            EQU     byte ptr [bp+4] ; indirizzamento cornice stack

EQUIP_FLAG      EQU     byte ptr ds:[10h] ; (nell'area dati di visualizzazione

CGAbits         EQU     00100000b       ; bit per EQUIP_FLAG
MDAbits         EQU     00110000b

_TEXT           SEGMENT byte public 'CODE'
                ASSUME  cs:_TEXT

                PUBLIC  _SetVmode
_SetVmode       PROC    near

                push    bp              ; mantiene registri del chiamante
                mov     bp,sp
                push    ds

                mov     ax,40h
                mov     ds,ax           ; DS -> Area dati di visualizzazione

                mov     bl,CGAbits      ; BL := bit che indicano la presenza di CGA

                mov     al,ARGn         ; AL := numero modalit video desiderata

                mov     ah,al           ; verifica se modalit desiderata 
                                        ;  monocromatica
                and     ah,7
                cmp     ah,7
                jne     L01             ; salta se modalit desiderata non  7 o 0Fh

                mov     bl,MDAbits      ; BL := bit che indicano la presenza di MDA

L01:            and     EQUIP_FLAG,11001111b
                or      EQUIP_FLAG,bl   ; imposta bit in EQUIP_FLAG

                xor     ah,ah           ; AH := 0 (numero funzione INT 10h)

                push    bp
                int     10h             ; richiama BIOS ROM per impostare modalit di visualizzazione
                pop     bp

                pop     ds              ; ripristina registri del chiamante e ritorna
                mov     sp,bp
                pop     bp
                ret

_SetVmode       ENDP

_TEXT           ENDS

                END
