/******************************************************************************
*                                                                             *
* Nome:  demo.c                                                               *
*                                                                             *
* Descrizione: Questo programma mostra come si possa incorporare in un        *
*         programma ad alto livello la grafica video in linguaggio Assembler. *
*                                                                             *
*                                                                             *
* Note:      Usare  MAKE DEMO  per creare questo programma. Avrete bisogno      *
*            dei seguenti strumenti:                                          *
*                                                                             *
*                    - C Microsoft                                            *
*                    - Macro Assembler Microsoft                              *
*                    - LINK                                                   *
*                                                                             *
*                                                                             *
*               Usare CGA, EGA, o VGA IBM, o hardware compatibile.            *
*                                                                             *
******************************************************************************/

#define	TRUE		1
#define	FALSE		0

#define	CGA		2
#define	EGA		3
#define	MCGA		4
#define	VGA		5

#define	Xmax		319
#define	Ymax		199

#define FivePI          (double)(5*3.1415926535)

main()
{
	static struct			/* per ID video */
	{
	  char	Subsystem;
	  char	Display;
	}		VIDstruct[2];

	int	VIDok = FALSE;

	int	x,y,Fgd;
	int	i;
	double	sin();


/* verifica presenza di hardware compatibile CGA */

	VideoID( VIDstruct );

	for( i=0; (i<=1) && !VIDok; i++ )
	  VIDok = ( VIDstruct[i].Subsystem == CGA ) ||
	          ( VIDstruct[i].Subsystem == EGA ) ||
	          ( VIDstruct[i].Subsystem == MCGA ) ||
	          ( VIDstruct[i].Subsystem == VGA );
	  
	if( !VIDok )
	{
	  printf( "\nNon trovo hardware video compatibile\n");
	  exit( 1 );
	}

/* traccia qualcosa nella modalit a 4 colori 320x200 */

	SetVmode( 4 );			/* la modalit 4 del BIOS  a 4 colori 320x200 */

	Line04( 0, Ymax/2, Xmax, Ymax/2, 3 );

	for( x=0; x<=Xmax; x++ )
	{
	  y = sin( FivePI * (double)x/(double)Xmax ) * (double)(Ymax/2);
	  y += Ymax/2;

	  Fgd = ( x%10 ? 2 : 3 );	/* seleziona valore di pixel di primo piano */

	  Line04( x, y, x, Ymax/2, Fgd );	/* traccia una o due linee */
	  Line04( x, Ymax-y, x, Ymax/2, 5-Fgd );
	}
}
